
/* This headerfile should ONLY be used by the device-dependent modules */
/* "u_pl_xxx.c", NEVER by a user program                               */

#define PLOT_STAT_OK             0
#define PLOT_STAT_NOMOREHANDLES  1
#define PLOT_STAT_NOMEMORY       2
#define PLOT_STAT_NOSUCHHANDLE   3
#define PLOT_STAT_NOMOREDEV      4
#define PLOT_STAT_NODISPLAY      5
#define PLOT_STAT_NOSUCHDEV      6
#define PLOT_STAT_OPENERROR      7
#define PLOT_STAT_NOSYMBOLS      8
#define PLOT_STAT_NODRIVER       9

#define MAXHANDLES 33


#ifdef VMS
typedef char symbolcoordtyp;
#else
typedef signed char symbolcoordtyp;
#endif

typedef struct symboltyp{
   unsigned char vec;
   symbolcoordtyp *x1,*x2,*y1,*y2;
}symboltyp;

typedef struct h {
   int xposw,yposw,xvmin, xvmax, yvmin, yvmax, clip;
   double xwmin, xwmax, ywmin, ywmax, xfact, xoffs, yfact, yoffs;
   double akt_x, akt_y, symbol_factor;
   char name[80];
   int devtype;
   unsigned long capabilities;
   int (* ploth_modify)(int ,/*struct h*,*/int ,int ,int ,int,char *);
   int (* ploth_getdevice)(int,int*,int*,int*,int*);
   void (* ploth_line)(int,int,int,int,int);
   void (* ploth_point)(int,int,int);
   void (* ploth_polyline)(int,int,int*,int*);
   int (* ploth_setfg)(int,int);
   int (* ploth_getfg)(int);
   int (* ploth_setbg)(int,int);
   int (* ploth_getbg)(int);
   void (* ploth_settextalign)(int,int,int);
   void (* ploth_writetext)(int,int,int,char*);
   void (* ploth_erasetext)(int,int,int,char*);
   void (* ploth_graphmode)(int);
   void (* ploth_clear)(int);
   void (* ploth_textmode)(int);
   void (* ploth_close)(int);
   int  (* ploth_setmode)(int,int);
   int  (* ploth_getmode)(int);
   int (* ploth_getpointer)(int,int*,int*);
   int (* ploth_checkevent)(int,int*,int*);
   void (* ploth_polysymbol)(int,int,symboltyp,int*,int*);
   void (* ploth_rectangle)(int,double,double,double,double,int);
} handletyp;

typedef handletyp *handleptr;
