      integer mp,mprd,mprds,mprdn,kp,minsets
      real    p,up,op,ddp,pold,pmin,plast,pst

      common /par/ mp,mprd(maxco),mprds(maxco),mprdn(maxprd),
     &          kp(maxp),minsets(0:maxs),p(maxp),up(maxp),op(maxp),
     &          ddp(maxp),pold(maxp),pmin(maxp),plast(maxp),pst(maxp),
     &          np(maxp)

c     mp           = actual number of fit parameters
c     mpf          = number of free fit parameters (varied at the same time)
c     mprd(maxco)  = number of product parameters belonging to the
c                    correlation matrix
c     mprds(maxco) = (analog to mcs() in cor )
c    mprdn(maxpdr) = contains groups of i,j,k such that p(i)=p(j)*p(k)
c     kp(maxp)     = indicator; kp(i)=0 if p(i) is fixed
c                               kp(i)=i if p(i) is free
c     np(maxp)     = names of fit parameters (a16)
c     p(maxp)      = values of the fit parameters
c     up(maxp)     = lower (untere) limit of parameter value
c     op(maxp)     = upper (obere)    "         "        "
c     ddp(maxp)    = stepwidths of the fit parameters used for numerical
c                    differentiation
c     pst(maxp)    = array for the last read values of p
c     pold(maxp)   = array for p of the last but one iteration
c     pmin(maxp)   = array for p with the smallest chi-square value
      integer    mco,mcon,kco,kcof,mr,mc,mrs,mcs,mrcet,mrce,mrces,kcp
      real       cpstor
      common /trcr/ mco,mcon,kco(maxco),kcof(maxco),
     &              mr(maxco),mc(maxco),mrs(maxco),mcs(maxco),
     &              mrcet,mrce(maxco),mrces(maxco),
     &              kcp(maxp),cpstor(maxsto),fpstor(maxsto),ncor(maxco)

c            mco    = largest number of a correlation matrices
c            mcon   = number of correlation matrices dim>0
c        kco(maxco) = correlation matrix (dim>0) number
c       kcof(maxco) = correlation matrix (dim>0) number where at least
c                     one parameter is not fixed
c         mr(maxco) = number of rows of the actual correlation matrix
c         mc(maxco) =   "       columns             "
c        mrs(maxco) = sum of rows of the actual correlation matrix
c                     including matrix k-1
c        c maxsto=     "     "    of elements of the storage vector for the
c                                                 correlation matrices
c        mcs(maxco) = sum of columns             "
c
c             mrcet = total number of elements of all correlation matrices
c       mrce(maxco) = number of elements of a correlation matrix
c      mrces(maxco) = sum of number of elements including matrix k-1
c                     mrces(1)=0; mrces(j)=mrces(j-1)+mrce(j-1)
c                                mrcet=mrcs(mco)+mrc(mco)
c       ncor(maxco) = names (a16) of correlation matrix
c         kcp(maxp) = kcp(i) is the parameter number naturally given by the
c                         increasing number of subspectra attached to the
c                         fit-parameter i.
c                         (maxp maximum number of fit-parameters)
c    cpstor(maxsto) = storage vector for correlation matrices
      integer       mpl,mpart,mplthsp,mplthss,mplths,mpaddsp,mpaddss,
     &              mpadds,mvaddsp,mvaddss,mtrp,mtpl,kpl,ipladd,ivadd,
     &              ivaddsp
      real          pl
      common /thorg/ mpl,mpart,
     &              mplthsp(0:maxs),mplthss(maxs,0:maxthss),
     &              mplths(maxs,0:maxthss),
     &              mpaddsp(0:maxs),mpaddss(maxs,0:maxthss),
     &              mpadds(maxs,0:maxthss),
     &              mvaddsp(0:maxs),mvaddss(maxs,0:maxthss),
     &              mtrp(maxp),mtpl(maxpl),kpl(maxpl),
     &              ipladd(maxpl),ivadd(maxpl),ivaddsp(maxs,0:maxp_sp),
     &              pl(maxpl),nthpl(maxpl),nstructfr(maxs,6)

c          maxthss = maximal number of theories to be linked
c           maxthsp = maximal number of frame theories to be linked =maxs*4
c             maxpl = maximum number of theory parameters
c
c                 mpl = actual number of theory parameters
c  mplthsp(0:maxs)= number of variables of frame theory i
c mplthss(maxs,0:maxthss)= number of variables of theory i of a subspectrum
c mplths(maxs,0:maxthss) = sum of variables including ssp k-1 of spectrum j
c                 mplths(1,0)=0
c                 mplths(j,0)=mplths(j-1,msspsp(j-1))+mplthss(j-1,msspsp(j-1))
c                 mplths(j,k)=mplths(j,k-1)+mplthss(j,k-1)
c
c ktheo(ks,0:maxthss,0:4) = theory number of (sub,sub)theory
c ktheo(ks,0,0) = 2 array ktheo(maxs,0,i=0,1,2) members
c ktheo(ks,0,1) =j framestructur0j is called
c ktheo(ks,0,2) =k case k in framestructur0j is called
c                m odd
c ktheo(ks,kss,m) =j in step m theory0j is called
c                m+1 even
c ktheo(ks,kss,m) =k in step m case k of theory0j is called
c  ntheossp(0:maxthss) = text (a80) specifying  theory n for a  subspectrum
c    ntheosp(0:maxthsp) = text (a80) specifying the frame theory for
c                         organization a spectrum
c istrss(maxs,0:maxthss) = mss numbers defining "subspectra" containing
c                             global variables
c     nstructfr(maxthsp,3)*24 = name of the frame theory (singular,plural)
c
c        kpl(maxpl) = kpl(i) is the theory parameter number naturally
c                     given by increasing number of subspectra
c                     attached to theory-parameter i.
c      nthpl(maxpl) = names (a16) of theory parameters attached to pl
c         pl(maxpl) = parameter values of the theories
c     pllast(maxpl) = values before last change
c        bpl(maxpl) = logical bpl = pl.ne.pllast

       integer   mcl,icadd,icladd,icaddsp,mcthsp,mcthss,mcths,
     &           mcaddsp,mcaddss,mkaddsp,mkaddss,mkadds,mconcor
       real      con
      common /coorg/ mcl,
     &              icadd(maxc),icladd(maxc),icaddsp(maxs,0:maxc_sp),
     &              mcthsp(0:maxs),mcthss(maxs,0:maxthss),
     &              mcths(maxs,0:maxthss),
     &              mcaddsp(0:maxs),mcaddss(maxs,0:maxthss),
     &              mkaddsp(0:maxs),mkaddss(maxs,0:maxthss),
     &              mkadds(maxs,0:maxthss),mconcor(maxc),
     &              con(maxc),ncon(maxc)

c             maxc = maximum number of constants
c              mcl = actual number of constants
c  mcthsp(0:maxs) = number of global constants defined in frame theory i
c mcthss(0:maxs,0:maxthss)= number of constants defined in theory k
c mcths(maxs,0:maxthss) = sum of constants including ssp k-1 of spectrum j
c                 mcths(1,0)=0
c                 mcths(j,0)=mcths(j-1,msspsp(j-1))+mcthss(msspsp(j-1))
c                 mcths(j,k)=mcths(j,k-1)+mcthss(k-1)
c
c       con(maxc)  = values of the constants of subspectra k
c       ncon(maxc) = names (a16) of the constants of subspectra k
c       cono(maxc) = old values before last change
c       bcon(maxc) = con().ne.cono()


      character    nthpl*32,np*60,ncon*40,ncor*16,nstructfr*24,fpstor*4

c    mos      corr  corread   psave    subr    sdel      theostr  parm
c     i       mp    mp        mp       mp      mp        mp       mp
c     i       mprd
c     i       mprds
c     i       mprdn                    mprdn
c     i       kp    kp        kp       kp                         kp
c     i       p     p         p        p       p                  p
c     i       up    up        up               up                 up
c     i       op    op        op               op                 op
c     i       ddp   ddp       ddp              ddp                ddp
c     i       pst                                                 pst
c     i       np    np        np       np      np                 np
c     i       mco   mco       mco      mco     mco        mco     mco
c     i       mcon  mcon                       mcon       mcon    mcon
c     i       kco
c     i                                kcof                       kcof
c     i       mr    mr        mr       mr      mr                 mr
c     i       mc    mc        mc       mc      mc                 mc
c     i       mrs   mrs       mrs      mrs     mrs                mrs
c     i       mcs   mcs                mcs     mcs                mcs
c             mrcet mrcet                      mrcet
c     i       mrce  mrce               mrce    mrce
c     i       mrces mrces     mrces    mrces   mrces
c     i       kcp   kcp       kcp      kcp     kcp                kcp
c     i       cpstorcpstor    cpstor   cpstor  cpstor
c     i       ncor  ncor      ncor                                ncor

c    mos      corr  corread   psave    subr    sdel      theostr  parm  thxx
c     i       mpl   mpl                        mpl       mpl
c     i             mplthsp   mplthsp          mplthsp   mplthsp
c     i             mplthss  mplthss         mplthss  mplthss
c     i             mplths    mplths   mplths  mplths
c     i             mpaddsp                    mpaddsp   mpaddsp
c     i             mpaddss  mpaddss         mpaddss  mpaddss
c     i             mpadds                     mpadds
c     i             mvaddsp                    mvaddsp
c     i             mvaddss                   mvaddss
c     i             mvadds    mvadds           mvadds    mvadds         mvadds
c     ktheo         ktheo     ktheo    ktheo   ktheo     ktheo
c     kpl    kpl    kpl       kpl      kpl     kpl       kpl
c                                              ipladd
c                   ivadd     ivadd     ivadd  ivadd     ivadd
c                   ivaddsp                    ivaddsp   ivaddsp
c     istrss       istrss   istrss          istrss   istrss
c     i       nthpl nthpl     nthpl            nthpl
c     i             nametheory nametheory                nametheory
c                                                        itheory
c                   nstructfr nstructfr                  nstructfr
c

c    mos      corr  corread   psave    subr    sdel      theostr  parm  thxx
c    i              mcl       mcl      mcl     mcl       mcl      mcl
c                   icadd     icadd            icadd     icadd
c                   icladd                     icladd
c                   icaddsp                    icaddsp   icaddsp
c    i              mcthsp    mcthsp           mcthsp    mcthsp   mcthsp
c    i              mcthss   mcthss          mcthss   mcthss
c    i              mcths     mcths            mcths              mcths
c    i              mcaddsp                    mcaddsp
c    i              mcaddss                   mcaddss
c    i              mcadds    mcadds           mcadds    mcadds          mcadds
c    i              mkaddsp   mkaddsp          mkaddsp   mkaddsp
c    i              mkaddss  mkaddss         mkaddss  mkaddss
c    i              mkadds                     mkadds
c    i              con       con      con     con       con      con
c    i              ncon      ncon             ncon               ncon
c    i              mconcor            mconcor mconcor            mconcor







