c     author : h. spiering
c              institut f. anorg. u. anal. chemie
c              johannes gutenberg-universitaet
c              d-55099 mainz
c              last version october 2004
      
      subroutine fr_mossbauer(cmch,iss,info)
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'
      integer     iss,info
      integer     ifrth,iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &            jpolsource,jpolabsorber,
     &            idum1,idum2,nLG,nAS,nSC,idum3,ak8,sk8
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              iaddr(4),jpolsource,jpolabsorber,ifrth(6),              
     &              idum1,idum2,nLG,nAS,nSC,idum3,ak8,sk8,srw8,idex(7)
c    &              lstr1case,l_trans,nLG,nAS,nSC,nsampling,ak8,sk8,srw8


c      the subroutines  with theorynames:
c      subroutine th_22refindexsad   theoryname='2x2_ref_index_static'
c      subroutine th_11refindexsad   theoryname='1x1_refraction_index_static'
c      subroutine th_relaxglb        theoryname='11_refraction_index_dynamic'
c      subroutine th_relaxhalfintspintheoryname='Kramers_doublet-crystal_field'
c      subroutine th_refindexdyn     theoryname='scalar_refraction_index_dynamic'
c      require the following constants 
c     &          lstr1case,l_trans,nLG,nAS,nSC,nsampling,ak8,srw8


      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs,dum
      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,dumcs(icstrf-11)
      
      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,r_over_d,
     &        dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,r_over_d,
     &        dumvs(ivstrf-12)
      
      integer ibm,km,mode_drive,lstruct1,lstruct2,lstruct3,
     &        nstorTH2,nstorLG

      parameter (ibm=512,km=256)
      character cmch*4,ch1*1,text(3)*40,ch132*132,cp132*132

      integer i,mi,k1,k2,isub,ak2,sk2,kzl,kzla,kzls,ib,ib2,nchansp,
     &        jpollay,nstorint    

c*****************************************************************************
c
c      write(6,'(3a,i3,a,l3)') 'fr_mossbauer cmch=',cmch,' iss=',iss,
c     &           ' b_theory=',b_theory
      if(cmch.eq.'thna') then
       theoryname='Mossbauer radioactive source'
       thfrcase(1)='Mossbauer transmission(1)'         
       thfrcase(2)='Mossbauer reemission(2)'           
       thfrcase(3)='Mossbauer resonance reflection(5)' 
       thfrcase(4)='Mossbauer transmission_ext(3)'     
       thfrcase(5)='Mossbauer reemission_ext(4)'       
       return
      end if        

      if(cmch.eq.'data') goto 100
c*****************************************************************************


      
      nchansp=channels
      if(cmch.eq.'arr0') then
       ifrsto=0
        ib=convol
        if (ib.gt.ibm) ib=ibm
        ib2=ib*2
        if(abs(v_max).gt.0.0) then
         kzl=int(km*vm_SC/abs(v_max))
        else
         kzl=km
        end if
c       write(6,'(a,i5)') 'frame01 kzl=',kzl
        if(kzl.gt.0) then
         kzls=2*km
         kzla=kzl*2
         if(kzla.gt.2*km) kzla=2*km
        else
         kzla=2*km
         kzls=abs(kzl)*2
         if(kzls.gt.2*km) kzls=2*km
        end if
c        write(6,'(a,2i5)') 'frame01 kzla,kzls=',kzla,kzls
      
        sk2=kzls
        ak2=kzla
        sk8=sk2*4
        ak8=ak2*4
      
        if(kzla.gt.kzls) then
         nAS=sk2+ak2+ib2
         nSC=sk2+ib2
        else
         nSC=sk2+ak2+ib2
         nAS=ak2+ib2
        end if
        nLG=4*(nAS+nSC)
      
c        srw8=abs(v_max)/float(km)/8.
        
        nstorTH1=1               ! base
        nstorTH2=km+1            ! norm spectrum
        nstorLG=(nLG+1)+(nLG+2*mGa+1)+mGa+1    ! Lorentz-Gauss curves

        ifrsto=nstorLG+nstorTH1+nstorTH2+nchansp/2+maxsub*(1+maxthss)
       
        nstorTH=nstorLG
        nstorTHyy=nstorTH+nstorTH1+nstorTH2
        nstorSI=nstorTHyy+nchansp/2
        jpolsource=0
        jpolabsorber=0

c       lstuct1case is assigned in the main routine mossbauer during execution
        a_je=0
        Lp=0
        a_jg=0
c       reset of common/sym3j/  in include file comnuc.for
        return
       else if(cmch.eq.'arri') then 
        ifrsto=0
        call l_structure(iss,lstruct1,lstruct2,lstruct3)

      
        if(lstruct1.eq.1.and.lstruct3.gt.0) then
c         write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)      
         if(c3_prp(lstruct3).eq.'plrs') jpolsource=1
         ifrsto=km+1     ! storage for folded spectrum for each source site 
        end if
        if(lstruct1.eq.2.and.lstruct3.gt.0) then
c         write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)      
         if(c3_prp(lstruct3).eq.'plrs') jpolabsorber=1
        end if

        if(lstruct1.eq.2.and.lstruct2.gt.0) then
         if(lstruct3.eq.0) then
          jpollay=0
          ifrsto=100
         else if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1) then
          if(c3_prp(lstruct3).eq.'plrs') jpollay=1
          if(lstruct3.eq.istruct2(lstruct2)) then
           if(jpollay.eq.1) then
            ifrsto=4*(nAS+1)
           else
            ifrsto=nAS+1
           end if
          end if
         end if
        end if       
        if(lstruct1.eq.3.and.lstruct3.gt.0) then
c        detector is always assumed to be unpolarized
         ifrsto=nSC+1
        end if
       return
      else if(cmch.eq.'arre') then
c      storage for absorber function (sum over all sites)
       ifrsto=nAS+1
       if(jpolabsorber.eq.1) 
     &  ifrsto=4*(nAS+1)
        return
      end if ! arr0,i,e
      
      if(.not.b_theory) then
c       absolute address of nstorSI is known here
        nstorint=maxsub*(1+maxthss)
        do k1=1,nstorint
         array_fr(nstorSI+k1)=(0.,0.)
        end do
      end if

       srw8=abs(v_max)/float(km)/8.
       mode_drive=drive_mode

       mi=istruct2(istruct1(mstruct1))
      
c*****************************************************************************
      
      if(cmch.eq.'test') then
       k1=2
      else if(cmch.eq.'dfdp') then
       k1=3
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=4
      else if(cmch.eq.'plex') then
       k1=5
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=6
      end if
      
      goto (100,200,300,400,500,600),k1
c**********************************************************************
 100  continue
c     k1 input unit (file is opened in main program)
       i=int(drive_mode)
       if(i.le.2) data_str='y,dy'
       if(i.ge.3) data_str='y,dy,x'
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer
      
  200 continue
      
c      write(6,'(a)') ' before spec2exp_moss  test'
      k1=1
      call spec2exp_moss(k1,info)
c      write(6,'(a)') ' after spec2exp_moss  test'
      
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call spec2exp_moss(k1,info)
      return
c*****************************************************************************
c     subs, subt
  400 continue
      text(1)='           source'
      text(2)='         absorber'
      text(3)='  detector window'
      if(cmch.eq.'subt') goto 450
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncl)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncl)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncl),ch132(:ncl)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncl)
      write(nwr,'(/,a)') ch132(:ncl)
      call selectsusp(text)
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,' '
      print *,'                     subtraction of subspectra'
      call selectsubtract(text,isub)
      call drive(mode_drive)
      call subtract('moss',mi,isub,info)
      k1=1
      call spec2exp_moss(k1,info)
      call plotfold(cmch)
      k1=0
      k2=0
      if(b_theory) k1=1
      call xmosplo(k1,k2)
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       k2=1  ! 0: only plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
c     write(6,'(a,a)') '********* 500 ********',cmch
      
      if(cmch.eq.'dmod') then
       call plotfold(cmch)
      else
       call drive(mode_drive)
       if(b_theory) then
        k1=1
        call spec2exp_moss(k1,info)
        if(n_subset.gt.0) 
     &              call subspecplot('moss',mi,isub,info)
       end if
       call plotfold(cmch)
      end if
      return
      end
      
      subroutine selspec2exp(cmch,n1,info)
      character cmch*4
      integer n1,info

      if(cmch.eq.'moss') then
        call spec2exp_moss(n1,info)
      else if(cmch.eq.'stro') then
        call spec2exp_strob(n1,info)
      end if
      return
      end 


      
      subroutine spec2exp_moss(n1,info)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'
      
      integer km,n1,info
      parameter (km=256)

       integer    iaddr,idex,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &            nstorTH,idum1,nstorTHyy
c     &            lstr1case,l_trans,nLG,nAS,nSC,nsampling,ak8,sk8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,idum1,nstorTHyy,iaddr(5),
     &              idex(24)

      real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,th_dum,
     &              drive_mode,channels_vmax,om_samp,dumcs,dum
      common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,
     &              th_dum,drive_mode,channels_vmax,om_samp,
     &              dumcs(icstrf-12)

      integer idumvs      
      parameter (idumvs=ivstrf-12)
      real    avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,r_over_d,
     &        dumvs
      common/avstrf/avsp,f_factor,base,bg_fraction,v_max,
     &        channel_v0,v_max2,vphase2,v_max3,vphase3,geo,r_over_d,
     &        dumvs(idumvs)
      logical b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_roverd,b_dumvs
      common/bvstrf/b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,
     &        b_channel_v0,b_v_max2,b_vphase2,b_v_max3,b_vphase3,
     &        b_geo,b_roverd,b_dumvs(idumvs)
      
      common/atos/thyy(maxn),theoy(maxn)
       
      parameter(idumscrt=maxscrt-4*maxn-5-maxn*maxpf-2*maxpf-maxco)
      common/scrt/dfdp(maxn),ddpk,ib_df,kana,
     &            dfdpk(maxn,maxpf),dather(maxn),idfsum(maxpf),
     &            ukk(maxpf),dpudp,ijv(maxco),
     &            yth(-maxn:maxn),idumsc(idumscrt)

      
      real velocity,geof,dfdgeo
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
  
      logical b_total,b_fresonant,b_nonlinear,b_scale,b_drive,b_residual
      
c      write(6,'(a,8L5)')
c     & 'b_vsp,b_base,b_f_factor,b_bg_fraction,b_geo,b_v_max2=',
c     & b_vsp,b_base,b_f_factor,b_bg_fraction,b_geo,b_v_max2
c      write(6,'(3(a,i6))') ' idumscrt=',idumscrt
c      write(6,'(a,f10.1)') ' ***spec2exp_moss base=',base


      if(base.eq.0.) then
        info=1
        infotext(1)=
     &  'theory/x_Mossbauer_spectrum/parameter/global/base0'
        infotext(2)='**error** base = 0 '
        infotext(3)=' '
        return
      end if
      
      nomsamp=om_samp+1.0
      oms2=nomsamp**2
      roverd2=r_over_d**2/4.0
 
      mode_drive=drive_mode
      nchansp=channels
      h=abs(channel_v0/channels_vmax-1.0)*10
      if(h.gt.1.0.or.nchansp.gt.maxn) then
        write(infotext(3),'(a,i5,2(a,f8.2))')
     & 'nchansp=',nchansp,' channels_vmax=',channels_vmax,
     &  ' channel_v0=',channel_v0
        info=10*h
        if(info.le.0) info=1
        infotext(1)=
     &   'theory/x_Mossbauer_spectrum/global_pa/ch_vmax/ch_v0'
        infotext(2)='**error** with one of the size of'//
     &      ' channels,channels_vmax,channel_v0'
        return
       end if
c     write(6,'(a,f10.3)')' frame01 spec2exp_moss fresonant=',fresonant
      
      nchansp2=nchansp/2
      ka=nstorTH+2

      if(ifrcase.eq.5) then
       call mossbauer_refl(b_total)
      else
       call mossbauer_trm(b_total)
      end if
c      write(6,'(a,l5,f12.4)')' fr_mossbauer  b_total,ddpk=',b_total,ddpk

      b_nonlinear=b_v_max2.or.b_vphase2
     &                    .or.b_v_max3.or.b_vphase3
      b_scale=b_v_max.or.b_channel_v0.or.b_nonlinear.or.b_roverd
      dv=abs(v_max)/float(km)

      b_fresonant=b_f_factor.or.b_bg_fraction
      fresonant=f_factor*(1.0-bg_fraction)
      if(fresonant.gt.1.) write(nwr,'(2a)')
     &      '**warning** fresonant larger than 1'
      
      
c      write(6,'(a,4i6)') ' ***spec2exp_moss nstorTH,nstorThyy=',
c     &       nstorTH,nstorThyy

      k1=n1
      goto (100,200,300),k1
      
 100   continue
c      calculation of thyy
      
       b_drive=b_geo.or.b_scale
       if(b_base.or.b_fresonant.or.b_drive.or.b_roverd.or.b_total)then
        call drive(mode_drive)
      
        do j =0,km
         yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
         yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
        end do
        do k=1,km/4
         yth(-km-k)=yth(-km)
         yth(km+k) =yth(km)
        end do
c        write(6,'(a,3f15.4)')' base,f_factor,bg_fraction=',
c     &                         base,f_factor,bg_fraction
c       write(6,'(a,f10.4,2i5)')'v(j),dv,nchannel,nomsamp=',dv,nchansp,nomsamp
c       write(6,'(8i6)') (int(velocity(j)/dv),j=1,nchansp,64)
c        write(6,'(4e15.6)') (yth(j),j=-km,km,32)
c       write(6,'(4e15.6)') (geof(j),j=1,nchansp,128)
c        write(6,'(a,i3,2x,3g15.4)')' nomsamp,roverd2,oms2=',
c     &                         nomsamp,roverd2,oms2

        do j=1,nchansp
         ff=0.0
         geo_oms2=geof(j)/oms2
         do k=1,nomsamp
          wn=2*k-1
          vn=velocity(j)/sqrt(roverd2*wn**2*geo_oms2+1.0)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=ff+(y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)))*wn
         end do
         thyy(j)=ff*geo_oms2
         end do
        do j=1,nchansp2
         array_fr(nstorTHyy+j)=cmplx(thyy(j),thyy(nchansp2+j))
        end do
c       write(6,'(a,4f15.1)') 'getthinf array_fr(1,2) =',
c    &  (array_fr(iarray_sp-1)),array_fr(iarray_sp)
       else
        do j=1,nchansp2
         thyy(j)=real(array_fr(nstorTHyy+j))
         thyy(nchansp2+j)=aimag(array_fr(nstorTHyy+j))
        end do
       end if
c       write(6,'(a,i6)')
c     & 'L100  (thyy(i),i=1,nchansp,64),nstorTHyy=',nstorTHyy
c       write(6,'(4e15.6)') (thyy(i),i=1,nchansp,128)
       b_theory=.true.
      return
      
 200  continue
c     derivatives
c      write(6,'(a,f15.5)') ' derivative step=',ddpk

      ib_df=0
      kana=0
      do j=1,nchansp2
       thyy(j)=real(array_fr(nstorTHyy+j))
       thyy(nchansp2+j)=aimag(array_fr(nstorTHyy+j))
      end do
c     parameter pl(j)

c     variable pl(1)
      if(b_base) then
       b_residual=b_geo.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c        write(6,'(a,f10.1)')  'derivative of base -----base=',base
        do j=1,nchansp
         dfdp(j)=thyy(j)/base
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
c     variable pl(3)
      if(b_geo) then
       b_residual=b_base.or.b_scale.or.b_fresonant
       if(b_residual) then
        goto 240
       else
c       write(6,'(a)')  '   derivative of geo ------------'
        do j=1,nchansp
         dfdp(j)=dfdgeo(j)*thyy(j)
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      end if
      
      if(b_fresonant) then
       if(b_bg_fraction.and.b_f_factor) then
        write(nwr,'(a)')
     &  '**warning parameters:bg_fraction,f_factor are correlated by 1'
       end if
       if(b_bg_fraction) then
c       variable pl(2)
        do j=1,nchansp
         dfdp(j)=-(thyy(j)-base*geof(j))/(1.0-bg_fraction)
        end do
        kana=1
        ib_df=1
        goto 250
       end if
      
       if(b_f_factor) then
c      variable pl(2)
        b_residual=b_base.or.b_geo.or.
     &                            b_scale.or.b_bg_fraction
        if(b_residual) then
         goto 240
        else
c        write(6,'(a)')  '   derivative of f_factor ------------'
         do j=1,nchansp
          dfdp(j)=(thyy(j)-base*geof(j))/f_factor
         end do
         kana=1
         ib_df=1
         goto 250
        end if
       end if
      end if
      
      if(b_scale) then
c        write(6,'(a)')  '   derivative b_scale=true ------------'
       b_residual=b_base.or.b_geo.or.b_fresonant
       if(b_residual) then
        goto 240
       else
        kana=0
c       write(6,'(a)')  'frame01 derivative b_scale=T b_residual=F'
        do j =0,km
         yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
         yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
        end do
        do k=1,km/4
         yth(-km-k)=yth(-km)
         yth(km+k) =yth(km)
        end do

        call drive(mode_drive)
        do j=1,nchansp
         ff=0.0
         geo_oms2=geof(j)/oms2
         do k=1,nomsamp
          wn=2*k-1
          vn=velocity(j)/sqrt(roverd2*wn**2*geo_oms2+1.0)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=ff+(y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)))*wn
         end do
         dfdp(j)=(ff*geo_oms2-thyy(j))/ddpk
        end do   ! j=1,nchansp
        ib_df=1
        goto 250
       end if
      end if   ! b_scale
      
       if(.not.b_total) goto 250
 240   kana=0
       do j =0,km
        yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
        yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
       end do
       do k=1,km/4
        yth(-km-k)=yth(-km)
        yth(km+k) =yth(km)
       end do
c       write(6,'(4e15.6)') (thyy(i),i=1,nchansp,128)

        call drive(mode_drive)
       do j=1,nchansp
         ff=0.0
         geo_oms2=geof(j)/oms2
         do k=1,nomsamp
          wn=2*k-1
          vn=velocity(j)/sqrt(roverd2*wn**2*geo_oms2+1.0)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=ff+(y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)))*wn
         end do
        dfdp(j)=(ff*geo_oms2-thyy(j))/ddpk
c        l=j/64
c        if(j.eq.l*64) write(6,'(a,6f15.3)')'thyy,ff*geo,thyy-ff*geo  :',
c     &   thyy(j),ff*geo_oms2,thyy(j)-ff*geo_oms2   
       end do   ! j=1,nchansp
       ib_df=1
c      write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32)

 250  continue
      return
      
 300  continue
      if(.not.b_theory) goto 310

      if(ifrcase.eq.5) then
       call mossbauer_refl(b_total)
      else
       call mossbauer_trm(b_total)
      end if
      do j =0,km
       yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant)
       yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant)
      end do
      do k=1,km
       yth(-km-k)=yth(-km)
       yth(km+k) =yth(km)
      end do
     
      do j=1,nchansp
         ff=0.0
         geo_oms2=geof(j)/oms2
         do k=1,nomsamp
          wn=2*k-1
          vn=velocity(j)/sqrt(roverd2*wn**2*geo_oms2+1.0)
          hi=vn/dv
          i=int(hi)
          y1=yth(i-1)
          y2=yth(i)
          y3=yth(i+1)
          hi=hi-float(i)
          ff=ff+(y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)))*wn
         end do
         thyy(j)=ff*geo_oms2
      end do
c      write(6,'(a,i6)') '.not.b_theorylc=true',nchansp
c      write(6,'(4e15.6)') (thyy(i),i=1,nchansp,64)

 310  return
      end
      
           

  
      subroutine  subspecplot(cmch,mi,isub,info)
      implicit none
      include 'comglb.for'
      include 'complt.for'
      include 'comdat.for'
      
      integer idumscrt,mi,nchansp,
     &        i,ip,l,ll,j,isub,k1,info
      real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,
     &        thyy,theoy,datx,errx,sym,subspectrum,plold
      
      common/acstrf/ dum(5),
     &               channels,dumcsp(icstrf-6)
      common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3)
      common/atos/thyy(maxn),theoy(maxn)

      parameter(idumscrt=maxscrt-maxn*maxsub-3*maxn)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),dumscrt(idumscrt)
      real velocity,geof,dfdgeo,p0
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      
      character cmch*4
      dimension plold(maxthss)

c     write(6,'(a,a)') '*********subroutine subspmoss********',cmch
      nchansp=channels

      do i=1,maxn
       dumscrt(i)=thyy(i)
      end do       
      
       call calpl('test')
      
       do  i=1,mi
        plold(i)=0.0
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      write(6,'(a,6f10.3)')' subsp-plold(1..)=',(plold(i),i=1,mi)
       nchansp=channels
      
       do  l=1,n_subset
        p0=0.0
        do j=1,mi
         call replace_wi(j,p0,info)          ! + write 0 to wi values
        end do
      
c       write(6,'(a,i4,a,30i3)')' l_subsp=',l,
c     &         ' n_int(l,ll)=',(n_int(l,ll),ll=0,n_int(l,0))
        do ll=1,n_int(l,0)
         ip=n_int(l,ll)
         call replace_wi(ip,plold(ip),info)  ! + write plold(ip) to wi values
        end do
      
        k1=3
        call selspec2exp(cmch,k1,info)
        do  i=1,nchansp
         subspectrum(i,l)=thyy(i)
        end do
c        write(6,'(a,i4)') 'frame01 subspectrum i=',l
c        write(6,'(4e15.6)') (thyy(i),i=1,nchansp,64)
       end do
      
       do  i=1,mi
        call replace_wi(i,plold(i),info)  ! + write plold(i) to wi values
       end do
c       call spec2exp_moss(k1,info)
      
      do i=1,maxn
       thyy(i)=dumscrt(i)
      end do 
      return
      end
      
      subroutine  subtract(cmch,mi,isub,info)
      implicit none
      include 'comglb.for'
      include 'complt.for'
      include 'comdat.for'
      
      integer idumscrt,mi,nchansp,
     &        i,j,jj,isub,k1,info
      real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs,dumscrt,
     &        thyy,theoy,datx,errx,sym,subspectrum,plold
      
      common/acstrf/ dum(5),
     &               channels,dumcsp(icstrf-6)
      common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3)
      common/atos/thyy(maxn),theoy(maxn)

      parameter(idumscrt=maxscrt-maxn*maxsub-3*maxn)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),dumscrt(idumscrt)
      real velocity,geof,dfdgeo,p0
      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn)
      
      character cmch*4
      dimension plold(maxthss)

c     write(6,'(a,a)') '*********subroutine subspmoss********',cmch
      nchansp=channels

      do i=1,maxn
       dumscrt(i)=thyy(i)
      end do       
      
c     write(6,'(a,i4)') ' ********** mi=',mi
      
       call calpl('test')
       do  i=1,mi
        plold(i)=0.0
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      subtract y - yy
      
c      absorber complete , source and detector window subtracted
      
       nchansp=channels
      
       p0=0.0
       do j=1,isub
        do i=1,mi
         call replace_wi(i,p0,info)  ! + write 0 to wi values
        end do
      
        do i=1,n_sub(j,0)
         jj=abs(n_sub(j,i))
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
        end do
      
        k1=3
        call selspec2exp(cmch,k1,info)
      
c      write(6,'(a)') ' ------1----back in subtract----------------'
      
        do i=1,nchansp
         data(mypt+i)=data(mypt+i)-(thyy(i)-base*geof(i))
        end do
       end do  ! isub
      
c      calculation of the theory of the stripped spectrum
       p0=0.0
       do i=1,mi
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values
       end do
      
       do i=1,n_sub(0,0)
        jj=n_sub(0,i)
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
       end do
      
       k1=3
         ! values are not reset by calpl, written on theory-array
       call selspec2exp(cmch,k1,info)
      
c      write(6,'(a)') ' ------2----back in subtract----------------'
c      restore parameters
       call calpl('test')

      do i=1,maxn
       thyy(i)=dumscrt(i)
      end do 
      
      return
      end
      
