c     author : h. spiering
c              Am Damsberg 86
c              D-55130 Mainz
c              last version April 1999

      subroutine fr_synchrotron(cmch,jss,info)
c     synchrotron
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comnuc.for'

      integer    jss,info,
     &           ifrth,idex,mstruct1,istruct1,istruct2,iaddr,
     &           l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,
     &           nstorTH,nstorTH1,nstorTHyy,nstorSI,nTH1,nCP,idum1,nsrw,
     &           iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &           ak8,nomega,nstrob_order,jt0_ch,iT_max
      real        srw8
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     !13.9.05 
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),nstorTH,nstorTH1,nstorTHyy,nstorSI,
     &              iaddr(4),nTH1,nCP,idum1,nsrw,ifrth(4),                    
     &              iflag_basis,l_trans,nLG,nTH,ith_channels,nsampling,
     &              ak8,nomega,srw8,nstrob_order,jt0_ch,iT_max,idex(4)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
     &              th_channels,th_sampling, 
     &              strob_order,t1_window,t2_window,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,
     &              th_channels,th_sampling, 
     &              strob_order,t1_window,t2_window,dumcsp(icstrf-20)

      real      avsp,counts,background,Pxsi,Peta,Pzeta,
     &          t_shift,graz_angle,graz_min,phi_z,detekt_eff,
     &          counts_bunch,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &          t_shift,graz_angle,graz_min,phi_z,detekt_eff,
     &          counts_bunch,dumvsp(ivstrf-12)

      integer mscale,nchansp,moschannel,k_extension,
     &        iT_max2,nstorlg,lstruct1,lstruct2,lstruct3,
     &        nstorint,i,isub,k,k1,k2,m1,m3,jshift,nTH2,ncloc
      real    pi,rad,vector_k,cv_ET,schrw
c**************** user defined common block and definitions ******************
      character cmch*4,text(3)*40,formdata(4)*16,ch1*1,ch132*132,
     &          cp132*132

c*****************************************************************************

      if(cmch.eq.'thna') then
       theoryname='Synchrotron source'
       thfrcase(1)='time differential transmission spectrum(11)'
       thfrcase(2)='time differential reflection spectrum(21)'
       thfrcase(3)='time integral - rocking curve(Fourier)(22)'
       thfrcase(4)='time integral - rocking curve(24)'
       thfrcase(5)='prompt - rocking curve(23)'
       thfrcase(6)=' '
c      index <= 8
       return
      end if        
c*****************************************************************************
      ncloc=ncl
      if(ncloc.gt.132)ncloc=132

      nchansp=channels
      if(cmch.eq.'arr0') then
       ifrsto=0
      
       k_extension=ak_extension
       pi=atan(1.)*4.
       rad=pi/180.
       vector_k=2*pi/wavelength    ! /Angstroem
       cv_ET=100.*wavelength       ! mm/s*ns
       iflag_basis=nint(flag_basis)
       l_trans=0
       if(ifrcase.eq.11) l_trans=1
      
       if(ifrcase.le.22) then
         nsampling=8
 
        iT_max=nint(aiT_max)
         iT_max2=2**iT_max
         schrw=cv_ET/abs(T_bunch*iT_max2)
         i=2*v_max/schrw+1
         moschannel=1
         do while(i.gt.0)
          i=i/2
          moschannel=moschannel*2
         end do

         schrw=schrw*(moschannel-1)/moschannel
         v_max=schrw/2.0*(moschannel-1)

         nTH=moschannel*2**k_extension
         ak8=8*moschannel

         jt0_ch=t0_norm*moschannel/abs(T_bunch)
         ith_channels=moschannel

         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.3,a,i4,/,a,/a,i3)')
     &      'actual used v_max=',v_max,
     &    '  and number of channels of the theory=',moschannel,
     &    '(in order to fulfil the FFT-conditions)',
     &    '  and number of channels for t0_norm=',jt0_ch
         end if

c        write(6,'(a,2f15.5,3i6)')
c     &  'T_bunch,aiT_max,iT_max,iT_max2,nth=',
c     &   T_bunch,aiT_max,iT_max,iT_max2,nth
c         write(6,'(a,4i6)') 'jt0_ch,nTH,nth,moschannel=',
c     &           jt0_ch,nTH,nth,moschannel

         if(nTH.gt.2*maxn) then
          info=nTH
          if(ifrcase.eq.22) then
           infotext(1)='theory/x_Synchrotron-time_integral/'
     &      //'synmos/channels'
          else
           infotext(1)='theory/x_Synchrotron-time_differential/'
     &      //'synmos/channels'
          end if
          infotext(2)=' number of channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         if(ifrcase.eq.11.or.ifrcase.eq.21) then
          nCP=nTH
          nsrw=1
          do while(2*nCP.gt.maxn)
           nCP=nCP/2
           nsrw=nsrw*2
          end do
         end if
c         write(6,'(a,3i4)')'frame02 nTH,nCP,nsrw=',nTH,nCP,nsrw

         jshift=abs(t_shift/T_bunch*2.*moschannel)+1
         if(jshift.gt.maxn/4) then
          info=jshift/4
          if(ifrcase.eq.22) then
           infotext(1)='theory/x_Synchrotron-time_integral/'
     &      //'synmos/timeshift'
          else
           infotext(1)='theory/x_Synchrotron-time_differential/'
     &      //'synmos/timeshift'
          end if
          infotext(2)='t_shift channels too large'
          infotext(3)=' '
          return
         end if

c        write(6,'(a,2i4)')'jshift=',jshift
         srw8=schrw/8.
         nLG=(nTH+moschannel)*8

         if(ifrcase.lt.22) then
          nTH1=nTH/iT_max2
          if(nTH1.gt.512) nTH1=512
          nTH2=8*(nCP+1)
         end if
         if(ifrcase.eq.22) then
          nTH1=int(ch_angle/4.)*2
          nTH2=int(ch_angle/4.)*2
         end if
         nstorLG=(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       else if(ifrcase.eq.23) then
c        ifrcase=23 prompt
         nsampling=8
         nCP=0
         nTH=0
         srw8=0.
         nstorLG=0
         nTH1=int(ch_angle/4.)*2
         nTH2=16+int(ch_angle/4.)*2
c-----------------------------ifrcase=24------------------------------
       else if(ifrcase.eq.24) then
         nstrob_order=strob_order      ! obtained from subtheory
c                                        called on level 0
c        vector_k=2*pi/wavelength    ! /Angstroem
c        cv_ET=100.*wavelength       ! mm/s*ns
         l_trans=0
         nsampling=2**th_sampling

         schrw=v_max/th_channels
         nomega=cv_ET/T_bunch/schrw
         ith_channels=nint(th_channels)
         nTH=ith_channels+nomega*nstrob_order
         ak8=8*nTH
         nTH=nTH*8/nsampling

         if(enwr(6)(1:1).eq.'y') then
          write(nwr,'(a,f10.2,2(a,i5))')
     &      ' v_max=',v_max,' nomega=',nomega,
     &    '  and number of channels of the theory=',nTH
         end if
         if(nTH.gt.2*maxn) then
          info=nTH
          infotext(1)='theory/x_Synchrotron-time_integral/'
     &                //'synmos//channels'
          infotext(2)=' number of theory channels too large'
          infotext(3)=' '
          return
         end if

         nCP=0
         srw8=schrw/8
         nLG=(2*ith_channels+nomega*nstrob_order)*8
 
         nTH1=int(ch_angle/4.)*2
         nTH2=int(ch_angle/4.)*2
         nstorLG=(nLG+1)+(nLG+mGa+1)+mGa/2+1    ! Lorentz-Gauss curves
       end if    ! ifrcase

c       nTH+1 is the out of synmos , nchansp/2 for thyy in synglobal
c       both on array_fr, yth is calculated from nTH+1 -> nchansp/2
c       and linear t_scale with tshift=0

c        write(6,'(a,6i8)')'frame_synmoss nTH1,nTH,nCP,nsrw=',
c     &                              nTH1,nTH,nCP,nsrw
        ifrsto=nstorLG+nTH1+nTH2+nchansp/2+maxsub*(1+maxthss)

c       the relativ addresses are stored after finishing
c       the entries arr0,i,e
        nstorTH=nstorLG
        nstorTH1=nstorTH+nTH1
        nstorTHyy=nstorTH1+nTH2 
        nstorSI=nstorTHyy+nchansp/2
c       the relativ addresses are reloaded before entering frtheoryxx
c       and changed to absolute addresses which are temporarily stored 
c       the 8 integers following c3_prp(maxthss) are considered to be 
c       relative addresses which during reloading are changed to absolute
c       addresses of the complex array  'array_fr(1:marray_sp). 
        a_je=0
        Lp=0
        a_jg=0
c       reset of common/sym3j/  in include file comnuc.for
        return
       else if(cmch.eq.'arri')then

         call l_structure(jss,lstruct1,lstruct2,lstruct3)
        ifrsto=0
        if(lstruct3.eq.0) then
         if(lstruct2.eq.0) then
c        lstruct1#0 , incoherent sum over mstruct1 members
          if(mstruct1.gt.1) ifrsto=512
         else
          if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1)then
           ifrsto=8*(nTH+1)
          end if
         end if
        end if

       return
      else if(cmch.eq.'arre')then
       ifrsto=0
       return
      end if   ! arr0,i,e

      mscale=scale

c      write(6,'(a,/,6i8,f12.3)')
c     & 'nTH,nTH1,ak8,nLG,nsampling,mscale,srw8=',
c     &                   nTH,nTH1,ak8,nLG,nsampling,mscale,srw8

c     initializing the array_fr section for nstorint (see subspectra)
c     (intensity of all subsets are 0)

      if(.not.b_theory) then
c       absolute address of nstorSI is known here
        nstorint=maxsub*(1+maxthss)
        do k=1,nstorint
         array_fr(nstorSI+k)=(0.,0.)
        end do
      end if


c     pointer
      
      if(cmch.ne.'data'.and.(.not.b_data)) mscale=1.
      m1=mstruct1
      m3=istruct2(istruct1(mstruct1))
     

c*****************************************************************************
c      write(6,'(a,a)') ' frame02 entered with=',cmch

      if(cmch.eq.'data') then
       k1=1
      else if(cmch.eq.'test') then
       k1=2
      else if(cmch.eq.'dfdp') then
       k1=3
      else if(cmch.eq.'subs'.or.cmch.eq.'subt') then
       k1=4
      else if(cmch.eq.'plex') then
       k1=5
      else if(cmch.eq.'dmod'.or.cmch.eq.'plot') then
       k1=6
      end if

      goto (100,200,300,400,500,600),k1
c**********************************************************************
 100  continue
      formdata(1)='y,dy'
      formdata(2)='y,dy,x'
      i=int(scale)
      if(i.lt.1.or.i.gt.2) i=1
      data_str=formdata(i)
      return
c************************************************************************
c     'test': theory function is calculated in subroutine mossbauer

  200 continue
      k1=1
      call synglobal(k1)
c     write(6,'(a)') ' after synglobal  test'
      return
c*****************************************************************************
c     derivatives df
  300 continue
      k1=2
      call synglobal(k1)
      return

c****************************************************************************
c     subs, subt
  400 continue
      text(1)='       scatterer'
      text(2)=' incoherent part'
      text(3)='                '
      if(info.eq.-1.and.n_subset.ne.0) return
      if(cmch.eq.'subt') goto 450
      print *,' '
      print *,'                 **warning** '
      print *,' subspectra are not additive in the time domain'
      ch1=' '
      if(b_data) then
       ch132=name_data
      else
       ch132=name_theory
      end if
      call chcenter(ch132,ch1,ncloc)
      cp132='plot of subspectra of'
      call chcenter(cp132,ch1,ncloc)
      print *,' '
      write(nwr,'(a,/,a)') cp132(:ncloc),ch132(:ncloc)
      ch132='subspectra /added subspectra of'
      call chcenter(ch132,ch1,ncloc)
      write(nwr,'(/,a)') ch132(:ncloc)
      call selectsuspsyn(text)
      return
c*************************************************************
c  call of subtract
 450  continue
      print *,' '
      print *,'          subtraction of subspectra'
      print *,'      has no meaning in the time domain'
      return
c**************************************************************************
c     plot execute
c     different plot programs may be called due to a flag constant 
c     to be introduced as global constant
  500 continue
       
       k1=0
       if(b_theory) k1=1
       k2=1  ! 0: only 1 plot and return, 1: interactive plot
       call xmosplo(k1,k2)

       return
c**************************************************************************
c     display mode , filling of plotarray
 600  continue
      if(cmch.eq.'dmod') then
       call plotsyn(cmch)
      else  ! cmch='plot'
       if(b_theory)then
        k1=3
        call synglobal(k1)
        if(n_subset.gt.0)
     &             call subspectra2(m1,m3,'subs',isub,info)
         if(info.gt.0) return
       end if
c       write(6,'(a,a4,4i6)')' frame02 cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,int(scale)
       call plotsyn(cmch)
      end if

c**************************************************************************
      return
      end



      subroutine synglobal(n1)
c *****************************************************************
c     n1 = 0 error return
c     n1 = 1 call of theory
c     n1 = 2 derivatives
c     n1 = 3 call of theory , calpl is not called
c *****************************************************************
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for'

      integer     ifrth,idex,istr,dstr,iaddr,
     &            nstorTH,idum1,nstorTHyy,nTH1
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),nstorTH,idum1,nstorTHyy,iaddr(5),        !13.9.05 
     &              nTH1,ifrth(7),idex(16)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp(ivstrf-7)

      logical       b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_dumvsp
      common/bvstrf/b_vs,b_counts,b_background,b_Pxsi,b_Peta,b_Pzeta,
     &              b_t_shift,b_dumvsp(ivstrf-7)

      real    thyy,theoy,dfdp,ddpk,dfdpk,dather,ukk,dpudp,yth
      integer ib_df,kana,idfsum,idumsc,idumscrt
      logical b_total,b_residual
      common/atos/thyy(maxn),theoy(maxn)

      parameter(idumscrt=maxscrt-5*maxn-5-maxn*maxpf-2*maxpf)
      common/scrt/dfdp(maxn),ddpk,ib_df,kana,
     &            dfdpk(maxn,maxpf),dather(maxn),idfsum(maxpf),
     &            ukk(maxpf),dpudp,
     &            yth(-maxn:2*maxn),idumsc(idumscrt)


      real    x_exp,x_the,countsy,dx_the,dx_exp,xb_the,xb_exp,
     &        y1,y2,yi,ff,hi
      integer nexp,nexp2,nthe,iT_max,iT_max2,invers,jshift,
     &        ji,i,k,k1,n1,j,mscale

      common/ascale/  x_exp(maxn),x_the(maxn)
      character chcm*4



c      write(6,'(a,5i6)')'syngl n1,ifrcase,scale=',
c     &                         n1,ifrcase,mscale

      mscale=scale
      countsy=counts-background*channels
c      integral 0-inf is normalized to 1
c      write(6,'(a,4f10.2)') ' frame02 counts,background,channels=',
c     &    counts,background,channels
      nexp=channels
      nthe=nTH1*2
      nexp2=nexp/2

      if(ifrcase.ge.22) then
       countsy=countsy/channels*nTH1       
      else
       iT_max=aiT_max
       iT_max2=2**iT_max  
c      write(6,'(a,i6,f15.5)') 'iT_max2=',2**iT_max
      end if

      if(ifrcase.ge.22) then
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0)
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0)
       xb_the=graz_beg+t_shift
       xb_exp=graz_beg
       invers=0
       if(dx_the.lt.0) then
        invers=nexp+1
        dx_the=-dx_the
       end if
      else
       dx_the=abs(T_bunch)/nthe
       dx_exp=abs(T_bunch)/channels
       xb_the=t_shift
       xb_exp=0.0
       invers=0
       if(T_bunch.lt.0) invers=nexp+1
       xb_the=t_shift
      end if
c     warning** xb_exp is not correct if x-data are read from file
c     it is correct after calling x_scale()
      jshift=abs(xb_the/dx_the)+1
      chcm='expe'

c     write(6,'(8f10.5)') (yth(i)*100.,i=-2,nthe,16)
c     write(6,'(8f12.2)') (yth(i)*countsy,i=1,nTH1)
c     write(6,'(4(a,f10.5),a,i4)') ' ***synchrotron*** backgr=',
c    &         background,' aiT_max=',aiT_max,' dx_the=',dx_the,
c    &         '  t_shift=',t_shift,'  nexp=',nexp

      if(ifrcase.ge.22) then
       call synrocking(b_total)
      else
       call synchrotron(b_total)
      end if

c      write(6,'(a,6L5)')',b_total,b_background,b_counts,b_t_shift =',
c     &             b_total, b_background,b_counts,b_t_shift


      k1=n1
      goto (100,200,300),k1

 100  continue
c     calculation of thyy
      do j =1,nTH1
       yth(j)=real(array_fr(nstorTH+j))
       yth(j+nTH1)=aimag(array_fr(nstorTH+j))
      end do

c      write(6,'(a,2i6,3f10.3)')
c     & 'frame02 nstorTH,nTH1,xb_the,dx_the=',
c     &          nstorTH,nTH1,xb_the,dx_the
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1,8)


      call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                    nthe,dx_the,xb_the,chcm)
      ji=abs(invers-1)
      hi=(x_exp(ji)-xb_the)/dx_the
      i=int(hi)
c      write(6,'(a,4i6,f10.3)')'ji,i,nthe,jshift,hi=',ji,i,nthe,jshift,hi
      if(ifrcase.ge.22) then
       do k=0,jshift+1
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+abs(i)+1
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      end if
c      write(6,'(6g12.2)') (yth(k),k=1,2*nTH1+4)

c      write(6,'(6f10.5)') (x_exp(i),i=1,nexp)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
c       y2=yth(i-2)+yth(i+2)
c       y1=yth(i-1)+yth(i+1)
c       aa=(2.0*y2-y1-yth(i))/14.0
c       bb=(-2.0*(yth(i-2)-yth(i+2))-yth(i-1)+yth(i+1))/10.0
c       cc=(-3.0*y2+12.0*y1+17*yth(i))/35.0
c       yi=cc+hi*(aa*hi+bb)
       y1=yth(i+1)
       y2=yth(i+2)
       yi=y1+hi*(y2-y1)
       thyy(j)=yi*countsy+background
      end do

      do j=1,nexp2
       array_fr(nstorTHyy+j)=cmplx(thyy(j),thyy(nexp2+j))
      end do
c      write(6,'(6g12.2)') (thyy(i),i=1,nexp,8)
      b_theory=.true.

      return

 200  continue
      ib_df=0
c     derivatives
c     ib_df=1: derivative calculated
c     ib_df=0 happens if a parameter of a set, wich is not currently 
c     fitted, is free. It will be fixed in the routine fit. 

c     analytical and numerical derivatives are handled fdifferently
c     integer kana (k analytical) = 1 indicates an analytical derivative

c     (the fact that a parameter x can mix up variables type 
c      complicates the situation. An analytical derivative of a variale 
c      can only be calculated, if it is not connected to a different 
c      parameter by the transformation matrix)  

c     variable background, counts are analytically derived 
c     the total number of variables of the set is contained in b_total
c     (for all variables of synchrotron, synrock) and the glabal 
c     variables of this routine: counts,background,t_shift
c     t_shift is numerically derived (enters x_scale by xb_the)

c      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
c     &          t_shift,graz_angle,graz_min,phi_z,dumvsp(idumvsp)

      b_total=b_total.or.b_t_shift

      b_residual=.not.(b_total.or.b_counts)
c     all variables unchanged but background

      if(b_background.and.b_residual) then
c       write(6,'(a)')  '   derivative of background ------------'
        do j=1,nexp
         dfdp(j)=1.0
        end do
        kana=1
        ib_df=1
        goto 250
      end if
c     for background derivative the last theory values were not neccessary
 
      nexp2=nexp/2
      do j=1,nexp2
       thyy(j)=real(array_fr(nstorTHyy+j))
       thyy(j+nexp2)=aimag(array_fr(nstorTHyy+j))
      end do
c     write(6,'(8f10.5)') (thyy(i),i=1,nexp,18)

      b_residual=.not.(b_total.or.b_background)
c     all variables but counts
      if(b_counts.and.b_residual) then
c       write(6,'(a)')  '   derivative of counts ------------'
        do j=1,nexp
         dfdp(j)=(thyy(j)-background)/countsy
        end do
        kana=1
        ib_df=1
        goto 250
      end if


c     numerical derivatives
      b_residual=.not.(b_total.or.b_background.or.b_counts)
c     (b_residual=.true.: parameter is connected only to variables 
c     of other sets 
      if(b_residual) goto 250  

      kana=0
      do j =1,nTH1
       yth(j)=real(array_fr(nstorTH+j))
       yth(j+nTH1)=aimag(array_fr(nstorTH+j))
      end do
      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if

      call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       y1=yth(i+1)
       y2=yth(i+2)
       ff=y1+hi*(y2-y1)
       dfdp(j)=(ff*countsy+background-thyy(j))/ddpk
      end do   ! j=1,nexp
      ib_df=1

 250  continue
      return

 300  continue
c     calculation of thyy

      if(.not.b_theory) goto 310
      if(ifrcase.ge.22) then
       call synrocking(b_total)
      else
       call synchrotron(b_total)
      end if

      do j =1,nTH1
       yth(j)=real(array_fr(nstorTH+j))
       yth(j+nTH1)=aimag(array_fr(nstorTH+j))
      end do

      if(ifrcase.ge.22) then
       do k=0,jshift
        yth(-k)=yth(1)
        yth(nthe+k+1)=yth(nthe)
       end do
      else
       do k=0,jshift+1
        yth(-k)=yth(nthe-k)
       end do
      end if
      call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)

      do j=1,nexp
       ji=abs(invers-j)
       hi=(x_exp(ji)-xb_the)/dx_the
       i=int(hi)
       if(i.le.0)i=i-1
       hi=hi-float(i)
       y1=yth(i+1)
       y2=yth(i+2)
       yi=y1+hi*(y2-y1)
       thyy(j)=yi*countsy+background
      end do
      do j=1,nthe
       ji=abs(invers-j)
       theoy(j)=yth(j)*countsy+background
      end do

 310  return
      end

      subroutine plotsyn(cmch)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comdat.for'
      include 'complt.for'

      integer     ifrth,idex,dstr,istr,iaddr,
     &            idum1,nstorTH1,nTH1,nCP,idum2,nsrw,idum
      real       srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),idum1,nstorTH1,iaddr(6),                 !13.9.05
     &              nTH1,nCP,idum2,nsrw,ifrth(4),idum(8),srw8,idex(7)
      
      integer      maxsubn,idumplot,idumscrt,idumsc,idumpl
      real*8       plotx,ploty,ploterry,plotres,plotxx,plotyy
      character*24 axesname,abscissa,ordinata,cmch*4,namechan*4,kform*8,
     &             axisformat*16,title*132
      parameter (maxsubn=maxsub*maxn,
     &           idumplot=MDBPLFT*2-12*maxn-maxsubn-maxn-5*maxplot-70)



      real          plotsub
      integer       iplotx,npntplot,nchanplot,n_subspectra
      common /plot/ plotx(maxn),ploty(maxn),ploterry(maxn),
     &              plotres(maxn),plotxx(maxn),plotyy(maxn),
     &              plotsub(maxsubn),
     &              iplotx(maxn),
     &              npntplot(maxplot),nchanplot(maxplot),n_subspectra,
     &              namechan(maxplot),kform(maxplot),axisformat(3),
     &              axesname(3),title,idumpl(idumplot)

      real          acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp
      common/acstrf/acsp,wavelength,uthick,
     &              unit_chi,aiT_max,v_max,
     &              ak_extension,T_bunch,scale,channels,
     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pxsi,Peta,Pzeta,
     &              t_shift,dumvsp(ivstrf-7)


      logical b_1256,b_3478
      parameter(idumscrt=maxscrt-maxn*maxsub-5*maxn)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),idumsc(idumscrt)

      real       thyy,theoy
      common/atos/thyy(maxn),theoy(maxn)

      real x_exp,x_the
      common/ascale/  x_exp(maxn),x_the(maxn)
      character chcm*4
      integer   mscale,nexp,n_plotsub,nresidue,nthe,ny,nyy,ns,
     &          i,ii,j,jj,k
      real      h,hm,htr,dx_the,dx_exp,xb_the,xb_exp,schrw

      mscale=scale

      if(cmch.eq.'dmod') then
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='erry'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)='*'

       if(ifrcase.ge.22) then
        display_mode(1)='angle scale (th at x data =txd) '
        display_mode(2)='angle scale, residual counts (txd) '
        display_mode(3)='channel scale, counts (txd) '
        display_mode(4)='channel scale,residual counts (txd) '
        display_mode(5)='angle scale (th all x =tx) '
        display_mode(6)='angle scale, residual counts (tx) '
        display_mode(7)='channel scale, counts (tx)'
        display_mode(8)='channel scale,residual counts (tx)'
       else
        display_mode(1)='time scale (th at x data =txd) '
        display_mode(2)='time scale, residual counts (txd) '
        display_mode(3)='channel scale, counts (txd) '
        display_mode(4)='channel scale,residual counts (txd)'
        display_mode(5)='time scale (th all x =tx) '
        display_mode(6)='time scale, residual counts (tx) '
        display_mode(7)='channel scale, counts (tx) '
        display_mode(8)='channel scale,residual counts (tx) '
        display_mode(9)='velocity scale, cross section'
        display_mode(10)='channel scale, cross section'
       end if
       return
      end if

      b_1256=.false.
      b_3478=.false.
      if(ifrcase.ge.22.and.ndisplay_mode.gt.8) ndisplay_mode=8
      goto(1,2,3,4,1,2,3,4,5,6), ndisplay_mode
c       display_mode(1)='angle, time scale'
 1     b_1256=.true.
       if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log(count) '
       axisformat(2)='%6.2f '
       goto 7
c       display_mode(2)='angle, time scale, residual counts'
 2      b_1256=.true.
        if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log(counts) '
       axisformat(2)='%6.2f '
       goto 7
c       display_mode(3)='channel scale'
 3     b_3478=.true.
       abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       goto 7
c       display_mode(4)='-channel scale, residual counts'
 4      b_3478=.true.
        abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       goto 7
c      display_mode(5)='velocity scale, cross section'
 5      abscissa='[mm/s] '
       ordinata='cross section '
       axisformat(1)='%6.1f '
       axisformat(2)='%10.2f '
       goto 7
c      display_mode(6)='channel scale, cross section'
 6     abscissa='channels '
       ordinata='cross section '
       axisformat(1)='%6.0f '
       axisformat(2)='%10.2f '
 7     continue



      if(b_1256.or.ndisplay_mode.eq.9) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
      else
       kform(1)='f6.0'
       kform(2)='f10.0'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
      end if
       kform(8)='*'

      n_subspectra=n_subset
      nexp=channels
      n_plotsub=n_subspectra
      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

      if(b_data) then
       do i=1,nexp
        daty(i)=data(mypt+i)
       end do
       do i=1,nexp
        erry(i)=data(mdypt+i)
       end do
      else
       if(mscale.eq.2) then
        write(nwr,'(a)')' **warning** scale=2 requires data; set to 1'
        mscale=1
       end if
      end if

      nresidue=0
      do ii=1,maxplot
       nchanplot(ii)=0
      end do
      do ii=1,6
       npntplot(ii)=(ii-1)*maxn
      end do



c       write(6,'(4(a,f10.3))')'counts=',counts,
c     &   ' T_bunch=',T_bunch, '  background=',background
c       write(6,'(6g12.2)') (thyy(i),i=1,256)
c      do j=240,250
c      write(6,'(i4,4x,2f15.6)') j,daty(j),erry(j)
c      end do
c      do j=240,250
c      write(6,'(i4,4x,f15.6)') j,theoy(j)
c      end do
c      write(6,'(a,i4)')'frame02 plot nexp=',nexp
c       write(6,'(a,a4,4i6)')'plotsyn  cmch,ifrcase,scale=',
c     &                                cmch,ifrcase,mscale
       nthe=nTH1*2

      if(ifrcase.ge.22) then
       dx_the=abs(graz_end-graz_beg)/(ch_angle-1.0)
       dx_exp=abs(graz_end-graz_beg)/(channels-1.0)
       xb_the=graz_beg+t_shift
       xb_exp=graz_beg
      else
       dx_the=abs(T_bunch)/nthe
       dx_exp=abs(T_bunch)/channels
       xb_the=t_shift
       xb_exp=0.0
      end if


      do i=1,nexp
       iplotx(i)=0
      end do


      nyy=0
      ny=0
      if(b_1256) then
       chcm='thex'
       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)
c       write(6,'(8f10.3)') (x_the(i),i=1,nthe)
       if(b_data) then
        do ii=1,nexp
         if(b_datfit(ii)) then
          ny=ny+1
          iplotx(ny)=1
          plotx(ny)=dble(x_exp(ii))
          h=abs(daty(ii))
          if(h.lt.0.1) then
           ploty(ny)=0.d0
           ploterry(ny)=1.d0
           ny=ny-1
          else
           ploty(ny)=dble(alog(h))
           ploterry(ny)=dble(1./erry(ii))
          end if
         end if
        end do
        if(b_theory.and.(ndisplay_mode.eq.2
     &               .or.ndisplay_mode.eq.6)) then
         nresidue=1
         ns=0
         do ii=1,nexp
          if(b_datfit(ii)) then
           ns=ns+1
           plotres(ns)=dble(daty(ii)-thyy(ii))
          end if
         end do
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.le.2.and.b_data) then
         nyy=nexp
         do ii=1,nexp
          plotxx(ii)=dble(x_exp(ii))
          plotyy(ii)=dble(alog(abs(thyy(ii)+0.1)))
         end do
        else
         nyy=nthe
         do ii=1,nthe
          plotxx(ii)=dble(x_the(ii))
          plotyy(ii)=dble(alog(abs(theoy(ii)+0.1)))
         end do
        end if
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*nyy
          npntplot(6+j)=6*maxn+ns
          nchanplot(6+j)=nyy
          do ii=1,nyy
           ns=ns+1
           plotsub(ns)=alog(abs(subspectrum(ii,j)+0.1))
          end do
         end do
        end if
       end if  ! b_theory
      end if ! log scale


      if(b_3478) then
       chcm='thec'
       call x_scale(mscale,nexp,dx_exp,xb_exp,
     &                     nthe,dx_the,xb_the,chcm)
c       write(6,'(8f10.3)') (x_the(i),i=1,nthe)
       if(b_data) then
        do ii=1,nexp
         if(b_datfit(ii)) then
          ny=ny+1
          iplotx(ny)=1
          plotx(ny)=dble(ii)
c           varray(ii)
          ploty(ny)=dble(daty(ii))
          ploterry(ny)=dble(erry(ii))
          if(daty(ii).lt.0.1) ny=ny-1
         end if
        end do
        if(b_theory.and.(ndisplay_mode.eq.4
     &               .or.ndisplay_mode.eq.8)) then
         nresidue=1
         ns=0
         do ii=1,nexp
          if(b_datfit(ii)) then
           ns=ns+1
           plotres(ns)=dble(daty(ii)-thyy(ii))
          end if
         end do
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.le.4) then
         if(b_data)then
          nyy=0
          do ii=1,nexp
           if(b_datfit(ii)) then
            nyy=nyy+1
            idumsc(nyy)=ii
            plotxx(nyy)=dble(x_exp(ii))
            plotyy(nyy)=dble(thyy(ii))
           end if
          end do
         else
          nyy=nthe
          do ii=1,nthe
            idumsc(ii)=ii
            plotxx(ii)=dble(x_the(ii))
            plotyy(ii)=dble(thyy(ii))
          end do
         end if
        else
         if(b_data)then
          k=1
          ii=1
          do while(.not.b_datfit(ii).and.ii.lt.nexp)
           do while(x_the(k).lt.x_exp(ii))
            k=k+1
           end do
           ii=ii+1
          end do
c         write(6,'(a,i4)')' plot ii_max=',k
          nyy=0
          do ii=k,nthe
           nyy=nyy+1
           idumsc(nyy)=ii
           plotxx(nyy)=dble(x_the(ii))
           plotyy(nyy)=dble(theoy(ii))
          end do
         else
          nyy=nthe
          do ii=1,nthe
           idumsc(ii)=ii
           plotxx(ii)=dble(x_the(ii))
           plotyy(ii)=dble(theoy(ii))
          end do
         end if
c         write(6,'(a,i4)')' plot nyy=',nyy
        end if
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*nyy
          npntplot(6+j)=6*maxn+ns
          nchanplot(6+j)=nyy
          do i=1,nyy
            ii=idumsc(i)
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts
c    &

c      display_mode(5)='velocity scale, cross section'
c      abscissa='[mm/s]'
c      ordinata='cross section'

c      display_mode(5)='channel scale, cross section'
c      abscissa='channels'
c       ordinata='cross section'

      if(ndisplay_mode.eq.9.or.ndisplay_mode.eq.10) then
       schrw=1.0
c       cv_ET=100.*wavelength
c       iT_max=aiT_max
c       iT_max2=2**iT_max

       if(ndisplay_mode.eq.9) schrw=8*srw8
c       if(ndisplay_mode.eq.9) schrw=cv_ET/abs(T_bunch*iT_max2)
       schrw=schrw*nsrw
c       write(6,'(a,3i8,f10.4)')
c     &   'array_fr( nn+),nCP,nsrw,schrw=',nn,nCP,nsrw,schrw

       nyy=0
       hm=0.
       do ii=-nCP,nCP-1
        jj=nstorTH1+(nCP+ii)*4
        nyy=nyy+1
        plotxx(nyy)=dble(schrw*ii)
        htr=0.0
c        do k=1,4
c         htr=htr+array_fr(jj+k)*conjg(array_fr(jj+k))
        do k=1,4,3
         htr=htr+real(array_fr(jj+k))
        end do
        if(hm.lt.htr) hm=htr
        plotyy(nyy)=dble(htr)
       end do
       plotyy(nyy-1)=dble(2.*hm)
       plotyy(nyy)=-dble(2.*hm)


c      write(6,'(a,2i4,f10.4)') ' nyy,nCP,schrw=',nyy,nCP,schrw
       n_plotsub=8
       n_subspectra=n_plotsub
       do j=1,n_plotsub/2
        ns=2*(j-1)*nyy
        npntplot(5+2*j)=6*maxn+ns
        nchanplot(5+2*j)=nyy

        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=real(array_fr(jj+j))
c         if(abs(ii).lt.5) write(6,'(2i4,f15.3)') j,ns,plotsub(ns)
        end do
c        write(6,'(a,4i8)') ' real nstorTH1,j,nyy=',nstorTH1,j,nyy
c        write(6,'(8f10.4)')
c     &     (plotsub(ii),ii=2*(j-1)*nyy+1,(2*j-1)*nyy,32)
        ns=(2*j-1)*nyy
        npntplot(6+2*j)=6*maxn+ns
        nchanplot(6+2*j)=nyy
        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=aimag(array_fr(jj+j))
c         if(abs(ii).lt.5) write(6,'(2i4,f15.3)') j,ns,plotsub(ns)
        end do
c       write(6,'(a,2i6)') ' aimag nstorTH1,j=',nstorTH1,j
c       write(6,'(8f10.4)') (plotsub(ii),ii=(2*j-1)*nyy+1,2*j*nyy)
       end do

      end if ! 5,6

      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
      end if
      if(nresidue.eq.1) nchanplot(4)=ny
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
      end if
c      write(6,'(a,f15.5)') ' in frame in plotf plotyy(2)=',plotyy(2)


c     write(6,'(8f10.4)') (plotx(ii),ii=1,ny,16)
c      write(6,'(a,3i8)') 'plotsyn xx nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotxx(ii),ii=1,nyy,16)
c      write(6,'(a,3i8)') 'plotsyn yy nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotyy(ii),ii=1,nyy,16)

      return
      end


      subroutine  subspectra2(m1,m3,cmch,isub,info)
      implicit none
      include 'comglb.for'
      include 'complt.for'
      include 'comdat.for'

      integer    m1,m3,isub,info,
     &           ifrth,idex,istr,dstr,iaddr,nTH1
      character frthname*64
      parameter (istr=6+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),frthname(2),
     &                         iaddr(8),nTH1,ifrth(7),idex(16)          !13.9.05

      integer   idumscrt
      parameter(idumscrt=maxscrt-maxn*maxsub-5*maxn)
      real        datx,errx,sym,subspectrum,daty,erry,dumscrt
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),dumscrt(idumscrt)

      real           dum,channels,dumcsp,thyy,theoy
      common/acstrf/dum(9),channels,dumcsp(icstrf-10)

      common/atos/thyy(maxn),theoy(maxn)

      character cmch*4
      real      plold,plold1,plold3,p0
      dimension plold(maxthss),plold1(maxthss),plold3(maxthss)

      integer  i,ip,ia,ie,j,jj,k,k1,l,ll,llm,lj,n1,nexp,nthe
 
c      write(6,'(a,a)') '*********subroutine subspectra2********',cmch

c        write(6,'(a,2i4)')'frame02 subspectra2 nexp,=',
c     &           int(channels)

      do i=1,maxn
       dumscrt(i)=thyy(i)
       dumscrt(maxn+i)=theoy(i)
      end do

      if(cmch.eq.'subs') then
       call calpl('test')

       do  i=1,m1
        plold1(i)=0.
       end do
       do  i=1,m3
        plold3(i)=0.0
       end do

       do  i=1,m1
        j=-(2*maxthss+i)
        call replace_wi(j,plold1(i),info)  ! - take out and write on plold(i)
       end do
       do  i=1,m3
        call replace_wi(-i,plold3(i),info)  ! - take out and write on plold(i)
       end do
c       write(6,'(a,6f10.3)')'frame02 plold1()=',(plold1(i),i=1,m1)
c       write(6,'(a,6f10.3)')'frame02 plold3()=',(plold3(i),i=1,m3)
       nexp=channels
       nthe=nTH1*2

       do  l=1,n_subset
        p0=0.0
        do  i=1,m1
         j=2*maxthss+i
         call replace_wi(j,p0,info)  ! + write 0 to wi values
        end do

        llm=n_int(l,0)
        ll=0
        do while(ll.lt.llm.and.n_int(l,ll).gt.0)
         ll=ll+1
        end do

c        write(6,'(a,2i4)')' frame02 ll,llm=',ll,llm
        if(ll.eq.llm.and.n_int(l,llm).gt.0) then
         do  i=1,m3
          call replace_wi(i,p0,info)  ! + write 0 to wi values
         end do
        end if
c      write(6,'(a,i4,a,5i4)')' l_subsp=',l,
c     &         ' n_int(l,ll)=',(n_int(l,ll),ll=1,4)
        ll=1
        do while(ll.le.llm.and.n_int(l,ll).gt.0 )
         ip=n_int(l,ll)
         if(ip.gt.maxthss) then
          i=ip-2*maxthss
c          write(6,'(a,2i4,f10.3)')'frame02 ip,plold1(i)=',ip,i,plold1(i)
          call replace_wi(ip,plold1(i),info)  ! + write plold(ip) to wi values
         else
          call replace_wi(ip,plold3(ip),info)  ! + write plold(ip) to wi values
         end if
         if(ll.eq.llm) goto 10 
         ll=ll+1
        end do
 10     continue
c       ll le llm is now guaranteed      8.2.06

        if(ll.lt.llm) then
         do lj=ll,llm,2
          ia=-n_int(l,lj)
          ie=-n_int(l,lj+1)
          do ip=ia,ie
c          write(6,'(a,i4,f10.3)')'frame02 ip,plold3(ip)=',ip,plold3(ip)
           call replace_wi(ip,plold3(ip),info)
          end do
         end do
        end if

        k1=3
        call synglobal(k1)

c        write(6,'(a,2i4)')'frame02 subspectra2 nexp,l=',nexp,l
        if(ndisplay_mode.le.4) then
         do  i=1,nexp
          subspectrum(i,l)=thyy(i)
         end do
        else
         do  i=1,nthe
          subspectrum(i,l)=theoy(i)
         end do
        end if
       end do

       do  i=1,m1
        j=2*maxthss+i
        call replace_wi(j,plold1(i),info)  ! + write plold(jj) to wi values
       end do
       do  i=1,m3
        call replace_wi(i,plold3(i),info)  ! + write plold(jj) to wi values
       end do
      end if  !  cmch=subs,test



      if(cmch.eq.'subt') then
c     write(6,'(a,i4)') ' ********** m1=',m1

       call calpl('test')
        do  i=1,m1
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      write(6,'(a,i2,a2,f15.5)') ' plold(',i,')=',plold(i)

c      subtract y - yy

c      absorber complete , source and detector window subtracted


       nexp=channels
       do k=1,nexp
        daty(k)=data(mypt+k)
       end do

       p0=0.0
       do j=1,isub
        do i=1,m1
         call replace_wi(i,p0,info)  ! + write 0 to wi values
        end do

        do i=1,n_sub(j,0)
         jj=abs(n_sub(j,i))
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
        end do

        k1=3
        call synglobal(n1)

c      write(6,'(a)') ' ------1----back in subtract----------------'

        do i=1,nexp
         daty(i)=daty(i)-thyy(i)
        end do
       end do  ! isub

c      calculation of the theory of the stripped spectrum
       p0=0.0
       do i=1,m1
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values
       end do

       do i=1,n_sub(0,0)
        jj=n_sub(0,i)
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
       end do

       k1=3
         ! values are not reset by calpl, written on theory-array
       call synglobal(n1)

c      write(6,'(a)') ' ------2----back in subtract----------------'
c      restore parameters
       call calpl('test')
      end if    ! cmch='subt'

      do i=1,maxn
       thyy(i)=dumscrt(i)
       theoy(i)=dumscrt(maxn+i)
      end do

      return
      end


