      subroutine frstr_mossbauer(l_nfrtheo,lstruct1,lstruct2,
     &                                           cmch,property)
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character*132 ch132,property,cmch*4,chth*8


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_nfrtheo=',l_nfrtheo,
     & ' subr= frstr_mossbauer  nameth_as=',nameth_as(:40)
      
      if(cmch.eq.'name') then
       l_nfrtheo=1         
c#########################################################################
       property  ='Mossbauer spectrum'                                      !name
       ntheory(1)='Mossbauer radioactive source'
c#########################################################################
       return
      end if

c     property defines the name of the helpfile: Mossbauer_spectrum.help

c     the different cases of theories are selected by the subroutine
c     thstr_frmossbauer:
c     l_nfrtheo=1 :'Mossbauer transmission'
c     l_nfrtheo=2 :'Mossbauer reemission'
c     l_nfrtheo=3 :'Mossbauer transmission_ext'
c     l_nfrtheo=4 :'Mossbauer reemission_ext'
c     l_nfrtheo=5 :'Mossbauer resonance reflection'

c     the frame routine fr_mossbauer has the theoryname (ntheory(1))
c     and the same list of cases (sequence arbitrary). The numbers 
c     in brackets (without any blanks!) at the end are again arbitrary
c     (different for each case). These numbers are accessible as ifrcase
c     in routines fr_mossbauer and th_mossbauer by the 'common/thpt/'
c     in comthe.for

c       theoryname='Mossbauer radioactive source'
c       thfrcase(1)='Mossbauer transmission(1)'         
c       thfrcase(2)='Mossbauer reemission(2)'           
c       thfrcase(3)='Mossbauer resonance reflection(5)' 
c       thfrcase(4)='Mossbauer transmission_ext(3)'     
c       thfrcase(5)='Mossbauer reemission_ext(4)'  


      chth='fr'//property(1:6)
      nstruct=' '
 
      goto(100,200,300,400)lstruct1+1
c------------------------------------------------------------------------
 100  continue
      
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=1 seq=2  chth='//chth  
       return
      end if

c      common/acstrf/acsp,uthick_w,
c                    dum(2),unit_chi,channels,vm_SC,convol,
c     &              th_dum,drive_mode,channels_vmax,om_samp,flag_basis
c-------------------------------------------------------
c     #    ask [n]
c     ##   from data file, ask [n]
c     ## y from data file, ask [y]
c     ##n  from data file, no ask
c--------------------------------------------------------
      
      
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      j=k-1
      jb=j+1

      strco(j+1)='vm_SC                   5     0.0'
c               ! value of source splitting'
c                 >0  gt absorber splitting
c                 =0  single line source
c                 <0  lt absorber splitting
      
      strco(j+2)='i_convol                6     128 '
                  ! limits of convolution integrals +/- 128
      
      strco(j+3)='nu_channels             4    ##n 1024 '
                ! channel number of the spectrum
      strco(j+4)='channels_vmax           9    ## y  256  '
                ! period of the drive unit
      strco(j+5)='drive_mode              8    ## y 1 '
                ! determines function for channel to velocity scale
      strco(j+6)='N_om_samp               10   ## y  0 '
                ! determines function for channel to velocity scale
      
      j=j+6
      if(l_nfrtheo.eq.3) then
c                 1                  012345
       strco(j+1)='unit_chi                3     1.0e-6 '
                ! susceptibility multiplied by
       strco(j+2)='flag_basis              11     1 '
                 ! switch for circular-linear basis 
       j=j+2
      end if
            
      strco(j+1)='#end#  11    seq1'
      strco(j+2)='#beg#'

      do k=jb,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do
      
      
c------------------------------------------------------------------------
c     variables of frame theory: source,absorber and detector orientation
c      common/cvsptrf/
c     &                  f_factor,base,bg_fraction,v_max,channel_v0,
c     &                  v_max2,channel_v02,v_max3,channel_v03,geo            10
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
      strtm(jm+1,1)='baseline                   1 1'
      strtm(jm+1,2)='(1) parameter base line '
      strth(1,1)='base            , 100000.0  0.0 0.0 10.0'     ! baseline
      strth(1,2)='base                    2    , 1 '
c                 1        0         012345
      strtm(jm+2,1)='source                  , ## 1 1'
      strtm(jm+2,2)='(1) parameter f_factor of the source'
      strth(2,1)='f_source        , 0.5  0.0  1.0  0.02'        !
      strth(2,2)='f_source                1    , 1  '        !
      
      strtm(jm+3,1)='source                  , ## y 1 1'
      strtm(jm+3,2)='(1) parameter back ground fraction of the source'
      strth(3,1)='bg_fraction     , 0.2  0.0  1.0  0.01'
      strth(3,2)='bg_fraction             3    , 1 '
      
      strtm(jm+4,1)='geometrie              , ## 2 2'
      strtm(jm+4,2)='parameter geometry, solid angle of radiation'
      strth(4,1)='geo              ,  0.000e-4   0.0 0.0 0.1'    
      strth(5,1)='r_over_d            0.0        0.0 0.0 0.1'
      strth(4,2)='geo              ,      10     , 1 0 '  
      strth(5,2)='r_over_d                11     , 0 1 '
      
      strtm(jm+5,1)='calibration                ,## 2 2'
      strtm(jm+5,2)='(2) parameters for calibration v_max,channel_v0'
      strth(6,1)='v_max             ,  8.0   0.0 0.0 0.05 '  !
      strth(7,1)='channel_v0        , 256.0  0.0 0.0 0.1 '   ! channel_v0
      strth(6,2)='v_max                   4     , 1 0'
      strth(7,2)='channel_v0              5     , 0 1 '
      
      strtm(jm+6,1)='non_linearity                ,## y 4 4'
      strtm(jm+6,2)='(4) non linearity parameters for calibration'
      strth(8,1)='vmax2            , 0.0   0.0 0.0 0.05 '   !
      strth(9,1)='vphase2          , 256.0  0.0 0.0 0.1 '   ! phase shift2
      strth(10,1)='vmax3            , 0.0   0.0 0.0 0.05 '  !
      strth(11,1)='vphase3         , 256.0  0.0 0.0 0.1 '   ! phase shift3
      strth(8,2)='vmax2                    6     1 0 0 0 '
      strth(9,2)='vphase2                  7     0 1 0 0 '
      strth(10,2)='vmax3                   8     0 0 1 0 '
      strth(11,2)='vphase3                 9     0 0 0 1 '
      jm=jm+6
      strtm(jm+1,1)='#end#  11 '
      strtm(jm+2,1)='#beg#'
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      
      if(l_nfrtheo.eq.1.or.l_nfrtheo.eq.3) then
      strcmt(0)=' 9  10'
      strcmt(1)=
     &'  source, absorber, detector are considered as layers, '
      strcmt(2)='  the absorber may consist of several layers and '
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'       layer 1        ___________________  source    '
      strcmt(5)='     _                                              '
      strcmt(6)=
     &'    \\  layer 2       ___________________  absorber   '
      strcmt(7)=
     &' n_period                    ...                      '
      strcmt(8)=
     &'    /_ layer n-1      ___________________  absorber   '
      strcmt(9)=
     &'       layer n        ___________________  detector window '
      
      strcmt(10)='source_absorber_detector   sp          , ##  2 '
      strcmt(11)=' '
      strcmt(12)='detector window (v=0) containes resonant nuclei '
      strcmt(13)='theory/'//chth//'/layer/detector'
      
      else if(l_nfrtheo.eq.2.or.l_nfrtheo.eq.5) then
      strcmt(0)=' 4 5'
      strcmt(1)=
     &'  source and scatterer(CEMS)  are considered as layers, '
      strcmt(2)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(3)= 
     &'       layer 1        __________________  source    '
      strcmt(4)=
     &'       layer 2        __________________  scatterer'
      
      strcmt(5)='source_scatterer       sp          , ##n  2 '
      strcmt(6)=' '
      strcmt(7)='detector window containes no resonant nuclei '
      strcmt(8)='theory/'//chth//'/layer/CEMS'
      
      else if(l_nfrtheo.eq.5) then
      strcmt(0)=' 10  11'
      strcmt(1)=
     &'  source and scatterer are considered as layers, '
      strcmt(2)='  the scatterer may consist of several layers and '
      strcmt(3)=
     &'  each layer n contains 0-N inequivalent lattice sites:'
      strcmt(4)=
     &'       layer 1        __________________  source    '
      strcmt(5)=
     &'       layer 2        __________________  scatterer (cover)'
      strcmt(6)='     _                                              '
      strcmt(7)=
     &'    \\  layer 3       __________________  scatterer'
      strcmt(8)=
     &' repetition                    ...                      '
      strcmt(9)=
     &'    /_ layer n-1      __________________  scatterer  '
      strcmt(10)=
     &'       layer n        __________________  scatterer (substrate)'
      
      strcmt(11)='source_scatterer       sp          , ##n  2 '
      strcmt(12)=' '
      strcmt(13)='detector window containes no resonant nuclei '
      strcmt(13)='theory/'//chth//'/layer/scatterer'
      end if
      return
c-----------------------------------------------------------------------
c     address of variables in source absorber/scatterer detector geometry
c      common/cfr1trf/Hext,thetaHe,phiHe,phi,theta,psi
 200  continue
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(lstruct2.gt.0) goto 210
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
      strtm(jm+1,1)='H_extern                ,# n 3 3'
      strtm(jm+1,2)='external magnetic field (lab) at the source'
      strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hext                     2    1 0 0  '
      strth(jh+2,2)='thetaHe                  3    0 1 0 '
      strth(jh+3,2)='phiHe                    4    0 0 1'
      
      jm=jm+1
      strtm(jm+1,1)='#end#  7  '
      strtm(jm+2,1)='#beg#'
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      strcmt(1)='source_layer       sc              #n  1 '
      strcmt(2)=' '
      strcmt(3)='number of layers of the source '
      strcmt(4)='theory/'//chth//'/layer/source'
      strcmt(5)='distribution of parameters at sites of the layer'
      
      return
 210  continue


       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1

      if(l_nfrtheo.eq.3.or.l_nfrtheo.eq.4) then

       strtm(jm+1,1)='x2_anisotropy            ,# 2 2'
       strtm(jm+1,2)='mean square <x2> of the sample layer'
       strth(jh+1,1)='d_x2                  ,  0.0  0.0 0.0  0.1'
       strth(jh+2,1)='x2_eta                ,  0.0  0.0 0.0  0.1'
       strth(jh+1,2)='d_x2                     12    1 0  '
       strth(jh+2,2)='x2_eta                   13    0 1  '

       strtm(jm+2,1)='x2_orientation           ,# 3 3'
       strtm(jm+2,2)='x2_orientation with respect to the sample layer'
       strth(jh+3,1)='x2_phi                , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='x2_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+5,1)='x2_psi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,2)='x2_phi                   14    1 0 0 '
       strth(jh+4,2)='x2_theta                 15    0 1 0 '
       strth(jh+5,2)='x2_psi                   16    0 0 1 '
       jm=jm+2
       jh=jh+5

       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do

      end if
      strtm(jm+1,1)='#end#  16 '
      strtm(jm+2,1)='#beg#'             
       
      strcmt(1)='source   s               #  1 1 '
      strcmt(2)=' '
      strcmt(3)='number of inequivalent sites of the source '
      strcmt(4)='theory/'//chth//'/sites/source'
      strcmt(5)='distribution of parameters of site number'
      
      return
c--------------------------------------------------------------------
c     Mosbauer scatterer
c      common/cfr1trf/pfr1,Hext,thetaHe,phiHe,phi,theta,psi,
c                                             axtheta,axphi,axomega
c     Mosbauer absorber
c      common/avfr2trf/avfr2,dum4(4),f_anisotrop,Hext,thetaHe,phiHe,
c     &                phi,theta,psi,dumvfr2(idumvfr2)
 300  continue

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

      if(lstruct2.gt.0) goto 310
      
       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1

      if(l_nfrtheo.eq.5) then
       strtm(jm+1,1)='H_extern                ,# 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the absorber'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     2    1 0 0  '
       strth(jh+2,2)='thetaHe                  3    0 1 0 '
       strth(jh+3,2)='phiHe                    4    0 0 1'
      
       jm=jm+1       

       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do

       strcmt(1)='scatterer_layer  sr  l l1=co li=sw ln=su #  3  3'
       strcmt(2)='l1=cover li=sandwich ln=substrate '
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='theory/'//chth//'/scatterer/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      
      else !  if(l_nfrtheo.ne.5) then
      
 
       strcmt(1)='absorber_layer  ab  l  l1=po ln=an      #  1  1'
       strcmt(2)='name of the absorber layer '
       strcmt(3)='number of layers of the absorber '
       strcmt(4)='theory/'//chth//'/absorber/layer'
       strcmt(5)='distribution of parameters at sites of the layer'
      
      end if
      strtm(jm+1,1)='#end# 7'
      strtm(jm+2,1)='#beg#'
      return
      
 310  continue
c      common/acfr2trf/rep_grp,aset,asymmetry,a_psi
c      common/avfr2trf/thicklay,re_chilay,ai_chilay,roughness,xfree,
c         Hext,thetaHe,phiHe,phi,theta,psi,axtheta,axphi,axomega
                       
c      absorber layer/ scaterer layer
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1 
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
c                1        0         012345
      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      jcb=jc+1
      j=jc

      if(l_nfrtheo.eq.5) then
       strco(jc+1)='rep.grp                 1  # 1.1 '
                ! layer belongs to a group which repeat with period
       j=jc+1
       strco(j+1)='#end#  1 seq'
       strco(j+2)='#beg#'

      
       strtm(jm+1,1)='thickn_lay              , 1 1'
       strtm(jm+1,2)='thickness of the layer'
       strth(jh+1,1)='thicklay        , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='thicklay                1    1  '
c                  1        0         012345
      
       strtm(jm+2,1) ='r_chi_electronic          , 1 1'
       strtm(jm+2,2) ='real part of chi_electronic of the layer  '
       strth(jh+2,1)='r_chilay        , 0.0  0.0 0.0  0.1'
       strth(jh+2,2)='r_chilay                2    1 '

       strtm(jm+3,1) ='i_chi_electronic          , 1 1'
       strtm(jm+3,2) ='imaginary part of chi_electronic of the layer'
       strth(jh+3,1)='i_chilay        , 0.0  0.0 0.0  0.1'
       strth(jh+3,2)='i_chilay                3    1'
      
       strtm(jm+4,1)='roughness                ,# 1 1'
       strtm(jm+4,2)='roughness of the layer  '
       strth(jh+4,1)='roughness        , 0.0  0.0 0.0  0.1'
       strth(jh+4,2)='roughness               4    1 '
       jm=jm+4
      
      else if(l_nfrtheo.eq.2.or.l_nfrtheo.eq.4) then      
       
       strcmt(1)='scatterer_layer   s       #  0  0'
       strcmt(2)='li=(1 0)  '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='theory/'//chth//'/scatterer/layer/sites'
       strcmt(5)='distribution of parameters of site number'

      else  if(l_nfrtheo.eq.1.or.l_nfrtheo.eq.3) then

      
       strtm(jm+1,1)='H_extern_a               ,# 3 3'
       strtm(jm+1,2)='external magnetic field (lab) at the absorber'
       strth(jh+1,1)='Hext             , 0.0  0.0 0.0   1.0'
       strth(jh+2,1)='thetaHe          , 0.0  0.0 0.0   1.0'
       strth(jh+3,1)='phiHe            , 0.0  0.0 0.0   1.0 '
       strth(jh+1,2)='Hext                     6    1 0 0  '
       strth(jh+2,2)='thetaHe                  7    0 1 0 '
       strth(jh+3,2)='phiHe                    8    0 0 1'
       jh=jh+3      
       jm=jm+1       

       strcmt(1)='absorber_layer   s       #  1  1'
       strcmt(2)=' '
       strcmt(3)='number of inequivalent sites of the absorber layer'
       strcmt(4)='theory/'//chth//'/absorber/layer/sites'
       strcmt(5)='distribution of parameters of site number'
      end if
 
      if(l_nfrtheo.eq.3.or.l_nfrtheo.eq.4) then
       
       strco(jc+1)='iset                    2   0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       strco(jc+2)='isymmetry               3   15 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       strco(jc+3)='n_psi                   4   0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)

       j=jc+3
       strco(j+1)='#end#  4 seq'
       strco(j+2)='#beg#'

       strtm(jm+1,1)='x2_anisotropy            ,# 2 2'
       strtm(jm+1,2)='mean square <x2> of the sample layer'
       strth(jh+1,1)='d_x2                  ,  0.0  0.0 0.0  0.1'
       strth(jh+2,1)='x2_eta                ,  0.0  0.0 0.0  0.1'
       strth(jh+1,2)='d_x2                     12    1 0  '
       strth(jh+2,2)='x2_eta                   13    0 1  '

       strtm(jm+2,1)='x2_orientation           ,# 3 3'
       strtm(jm+2,2)='x2_orientation with respect to the sample layer'
       strth(jh+3,1)='x2_phi                , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='x2_theta              , 0.0  0.0 0.0  1.0'
       strth(jh+5,1)='x2_psi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,2)='x2_phi                   14    1 0 0 '
       strth(jh+4,2)='x2_theta                 15    0 1 0 '
       strth(jh+5,2)='x2_psi                   16    0 0 1 '
       jm=jm+2
       jh=jh+5

       strtm(jm+1,1)='ax_texture               ,# 1 1'
       strtm(jm+1,2)='texture of the layer '
       strth(jh+1,1)='axtexture              , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='axtexture                17    1 '
       jm=jm+1

      end if
      
      if(j.ge.jcb)then      
       do k=jcb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do
      end if
      
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      strtm(jm+1,1)='#end# 17'
      strtm(jm+2,1)='#beg#'

      return
c--------------------------------------------------------------------
c      common/acfr1trf/v_sc_detect
c      common/avfr1trf/pvfr1,Hext,thetaHe,phiHe
c      detector

 400  continue
      if(lstruct2.gt.0) goto 410
      
      if(cmch.eq.'hdbk') return

      k=1
      do while(strco(k)(:5).ne.'#beg#')
       k=k+1
      end do
      jc=k-1
      jcb=k
      
      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
      
c                 1        0         012345
       strco(jc+1)='v_sc_detect             1  # 0'
       jc=jc+1
       strco(jc+1)='#end# 1    seq'
       strco(jc+2)='#beg#'
       do k=jcb,jb
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do
      
      strtm(jm+1,1)='H_extern                 ,# 3 3'
      strtm(jm+1,2)='external magnetic field (lab) at the detector'
      strth(jh+1,1)='Hext             , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaHe          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiHe            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hext                    2     1 0 0 '
      strth(jh+2,2)='thetaHe                 3     0 1 0 '
      strth(jh+3,2)='phiHe                   4     0 0 1 '
      jm=jm+1
      strtm(jm+1,1)='#end#  4 '
      strtm(jm+2,1)='#beg#'
      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do
      
      strcmt(1)='layer_detector  dt             #n  1   1'
      strcmt(2)=' '
      strcmt(3)='number of layers of the detector '
      strcmt(4)='theory/'//chth//'/layer/detector'
      
      return
 410  continue
      
      if(cmch.eq.'hdbk') return

      strcmt(1)='detector    s            #  1 1'
      strcmt(2)=' '
      strcmt(3)='number of inequivalent sites of the detector'
      strcmt(4)='theory/'//chth//'/sites/detector'
      strcmt(5)='distribution of parameters of site number'
      
      return
      end
      
      
