      subroutine cLORGAU(b_Lorentz,b_Gauss,
     &        gamnat,srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipos)
c     calculation of the Lorentz-Gauss functions
      include 'comglb.for'
      include 'comthe.for'

      parameter(a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,
     &          c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,
     &          wln2=0.832554611)
      parameter (idumscrd=maxscrd-(mGa+2))
      common/scrd/gauss(0:mGa+1),dumscrd(idumscrd)
      logical b_Lorentz,b_Gauss
      complex hc,hc1

c      write(6,'(2a,/,2l5,4f10.3,3i6)') 'cLORGAU b_Lorentz,b_Gauss,',
c     & 'gamnat,w_Lorentz,w_Gauss,srw8,iflag_Voigt,nLG,nstorFR',
c     & b_Lorentz,b_Gauss,gamnat,w_Lorentz,w_Gauss,srw8,
c     & iflag_Voigt,nLG,nstorFR

      iposLG=iarray_sp+nstorFR+1
      iposLor=iposLG+(nLG+1)
      iposGau=iposLor+(nLG+mGa+1)
      w_Gauss=abs(w_Gauss)
      w_Lorentz=abs(w_Lorentz)

      w_Gau=w_Gauss/(w_Lorentz+1.)
      w_Gau2=w_Gau*w_Gau

      if(iflag_Voigt.eq.1) then
       relarea=1./(w_Lorentz+1.)

       if(w_Gau.lt.0.01) then    ! Lorentz
        widthL2=(w_Lorentz+1.)*gamnat/2.
        disp=srw8/widthL2
        hp=-disp
        do  n=0,nLG
         hp=hp+disp
         array_fr(iposLor+n)=relarea/(1.0+hp*hp)*cmplx(hp,1.)
        end do
        ipos=iposLor
c        write(6,'(a,i6)') ' cLORGAU Voit=1, Lor : ipos=',ipos
       else
c       Voigt profile according to A.B. McLean, C.E.J. Mitchell and
c       D.M. Swantston, Queens's University, Kingston, Ontario, Canada

        wpi=1.772453851*relarea
        widthG2=w_Gauss*gamnat
        dxc=srw8/widthG2*2.0*wln2
        yc=wln2/w_Gau
        halpda1=c1*(yc-a1)-d1*b1
        halpda2=c2*(yc-a2)-d2*b2
        hbeta1=(yc-a1)**2
        hbeta2=(yc-a2)**2
        xc=-dxc
        do  n=0,nLG
         xc=xc+dxc
         beta1=hbeta1+(xc-b1)**2
         beta3=hbeta1+(xc+b1)**2
         beta2=hbeta2+(xc-b2)**2
         beta4=hbeta2+(xc+b2)**2
         alpha1=(halpda1+d1*xc)/beta1
         alpha3=(halpda1-d1*xc)/beta3
         alpha2=(halpda2+d2*xc)/beta2
         alpha4=(halpda2-d2*xc)/beta4
         vxy=alpha1+alpha2+alpha3+alpha4
         dvxy=( d1/2-alpha1*(xc-b1))/beta1+
     &        (-d1/2-alpha3*(xc+b1))/beta3+
     &        ( d2/2-alpha2*(xc-b2))/beta2+
     &        (-d2/2-alpha4*(xc+b2))/beta4
          array_fr(iposLG+n)=cmplx(xc*vxy+dvxy,yc*vxy)*wpi
        end do
        ipos=iposLG
       end if
      else

       if(b_Lorentz) then
        nLor=nLG+mGa
        widthL2=(w_Lorentz+1.)*gamnat/2.

c       Lorentz curve  with 1/8 stepwidth (srw8)
c
c       0---------------------------------------nLor

        relarea=0.5*gamnat/widthL2
        disp=srw8/widthL2
        h0=-disp
        do  n=0,nLor
         h0=h0+disp
         array_fr(iposLor+n)=relarea/(1.0+h0*h0)*
     &                                cmplx(h0,1.)
        end do

c         h1=0.
c         do j=1,nLor-1,2
c          h1=h1+ aimag(array_fr(iposLor+j))*2.
c         end do
c         do j=2,nLor-2,2
c          h1=h1+ aimag(array_fr(iposLor+j))
c         end do
c         h1=(h1*2.+aimag(array_fr(iposLor))+
c     &             aimag(array_fr(iposLor+nLor)))*2.
c         h1=h1/3.
c         do i=0,nLor
c          array_fr(iposLor+i)=array_fr(iposLor+i)/h1*(nLor+1)
c         end do
c
c         write(6,'(a,2f15.5)') ' relarea,h1=',relarea,h1/(nLor+1)
       end if     ! b_Lorentz

       widthG=w_Gauss*gamnat
       ibg=(6.*widthG/srw8+1.)/2.    ! 0.0005 precission
       ibg=2*ibg

       if(b_Gauss) then
        if(ibg.gt.mGa) ibg=mGa

        if(ibg.gt.0) then
c       -ibg--------0--------ibg           gauss

         width2=widthG/wln2/2.0   ! in units of gamma natural
         disp=srw8/width2
         h0=-disp
         do i=0,ibg+1
          h0=h0+disp
          gauss(i)=exp(-h0**2)
         end do
          h1=0.
         do j=1,ibg-1,2
          h1=h1+ gauss(j)*2.
         end do
         do j=2,ibg-2,2
          h1=h1+ gauss(j)
         end do
         h1=(h1*2.+gauss(0)+gauss(ibg))*2.
         h1=2.*h1/3.
         do i=0,ibg+1
          gauss(i)=gauss(i)/h1
         end do
         do i=0,ibg/2
          array_fr(iposGau+i)=cmplx(gauss(2*i),gauss(2*i+1))
         end do
        else
         do i=0,ibg/2
          gauss(2*i)=real(array_fr(iposGau+i))
          gauss(2*i+1)=aimag(array_fr(iposGau+i))
         end do
        end if
       end if    ! b_Gauss


c      convolution with exp(-x**2/(sGgL*gamnat)**2)
c
c      0------------------------------------nLG---nLor
c                                     ibg----0----ibg
c      0------------------------------------nLG

c      this convolution is calculated with stepwidth srw8

c      write(6,'(a,i4)')  ' ####cLORGAU ibg=',ibg
       if((b_Lorentz.or.b_Gauss).and.ibg.gt.0) then
        ipos=iposLG
c       write(6,'(a,i4)')  ' ####cLORGAU iposLGau=',ipos
        do i=0,nLG
         hc=(0.,0.)
         do j=-ibg+1,-1,2
          ij=i+j
          if(ij.gt.0) then
           hc=hc+gauss(-j)*array_fr(iposLor+ij)*2.
          else
           hc=hc-gauss(-j)*conjg(array_fr(iposLor-ij))*2.
          end if
         end do
         do j=1,ibg-1,2
          hc=hc+gauss(j)*array_fr(iposLor+i+j)*2.
         end do
         do j=-ibg+2,-2,2
          ij=i+j
          if(ij.gt.0) then
           hc=hc+gauss(-j)*array_fr(iposLor+ij)
          else
           hc=hc-gauss(-j)*conjg(array_fr(iposLor-ij))
          end if
         end do
         do j=0,ibg-2,2
          hc=hc+gauss(j)*array_fr(iposLor+i+j)
         end do
         ij=i-ibg
         if(ij.gt.0) then
          hc1=array_fr(iposLor+ij)
         else
          hc1=-conjg(array_fr(iposLor-ij))
         end if

         hc=hc*2.+gauss(ibg)*(hc1+array_fr(iposLor+i+ibg))
c        cLG(i,iset)=cmplx(hr,hi)/3.
         array_fr(iposLG+i)=hc/1.5
        end do
       else
        ipos=iposLor
c       write(6,'(a,i4)')  ' ####cLORGAU iposLor=',ipos
       end if           ! if ibg >0
      end if  ! iflag_Voigt=1

c     write(6,'(a,6f10.1)')'###cLORGAU real(array_fr(iarray_sp+1-6))=',
c    &                           (real(array_fr(iarray_sp+i)),i=1,6)
c     write(6,'(a,i4)')  '###cLORGAU array_fr(ipos+0-5),ipos=',ipos
c     write(6,'(6f12.4)') (array_fr(ipos+i*8),i=0,5)

c     If a Gauss broadening is used (simulating
c     a hyperfine field distribution), the sum of the Gauss function
c     values (weighting factors)  have to be 1.

c     end of calculation of Lorentz-Gauss function
      return
      end





      subroutine aLORGAU(b_Gauss,Eagd,gamnat,srw,
     &                   w_Lorentz,w_Gauss,nLG,iflag_Voigt)
      include 'comglb.for'
      include 'comthe.for'

      parameter (mLor=mLG+mGa,
     &           idumscrd=maxscrd-2*(mLG+1)-2*(2*mLG+1)
     &                           -2*(2*mLor+1)-(mGa+2))
      real w_Lorentz,w_Gauss,sTr,Eagd
      complex cLG,cLOR
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),cLOR(-mLor:mLor),
     &            gauss(0:mGa+1),dumscrd(idumscrd)
      logical b_Gauss
      complex hc
      parameter(a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,
     &          c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,
     &          wln2=0.832554611)

c      write(6,'(2a)')' aLORGAU:',
c     &'b_Gauss,Eagd,gamnat,srw,w_Lorentz,w_Gauss,nLG,iflag_Voigt'
c      write(6,'(L5,f12.5,f8.4,f10.5,2f8.3,2x,i6,i4)')
c     & b_Gauss,Eagd,gamnat,srw,w_Lorentz,w_Gauss,nLG,iflag_Voigt

c      1/(j*srw8-Eagd)+iG/2) =(j*srw8-Eagd)/(j*srw8-Eagd)**2+G**2/4)
c                            -iG/2/(j*srw8-Eagd)**2+G**2/4)



      iposLG=iarray_sp+nstorFR+1
      iposGau=iposLG+2*(nLG+1)+mGa

      w_Gau=abs(w_Gauss)/(w_Lorentz+1.)
      w_Gau2=w_Gau*w_Gau

      if(iflag_Voigt.eq.1) then
        relarea=1./(w_Lorentz+1.)


       if(w_Gau.lt.0.01) then    ! Lorentz
        widthL2=(w_Lorentz+1.)*gamnat/2.
        disp=srw/widthL2
        hp=-Eagd/widthL2-disp*float(nLG+1)
        do  n=-nLG,nLG
         hp=hp+disp
c         if(abs(n).lt.3)write(6,'(a,f10.4)') 'cLG(n),hp=',hp*100.
         cLG(n)=relarea/(1.0+hp*hp)*cmplx(hp,1.)
        end do
c       write(6,'(a,f10.4)') 'cLG(n),Eagd=',Eagd
c       write(6,'(i4,2f12.3)') (n,cLG(n)*100.,n=-5,5)
       else
c       Voigt profile according to A.B. McLean, C.E.J. Mitchell and
c       D.M. Swantston, Queens's University, Kingston, Ontario, Canada

        wpi=1.772453851*relarea
        widthG2=w_Gauss*gamnat
        yc=wln2/w_Gau
        halpda1=c1*(yc-a1)-d1*b1
        halpda2=c2*(yc-a2)-d2*b2
        hbeta1=(yc-a1)**2
        hbeta2=(yc-a2)**2

        dxc=srw/widthG2*2.0*wln2
        xc=-Eagd/widthG2*2.0*wln2-dxc*float(nLG+1)
        do  n=-nLG,nLG
         xc=xc+dxc
         beta1=hbeta1+(xc-b1)**2
         beta3=hbeta1+(xc+b1)**2
         beta2=hbeta2+(xc-b2)**2
         beta4=hbeta2+(xc+b2)**2
         alpha1=(halpda1+d1*xc)/beta1
         alpha3=(halpda1-d1*xc)/beta3
         alpha2=(halpda2+d2*xc)/beta2
         alpha4=(halpda2-d2*xc)/beta4
         vxy=alpha1+alpha2+alpha3+alpha4
         dvxy=( d1/2-alpha1*(xc-b1))/beta1+
     &        (-d1/2-alpha3*(xc+b1))/beta3+
     &        ( d2/2-alpha2*(xc-b2))/beta2+
     &        (-d2/2-alpha4*(xc+b2))/beta4
          cLG(n)=cmplx(xc*vxy+dvxy,yc*vxy)*wpi
        end do
       end if
      else
c      convolution numerically

       widthG=w_Gauss*gamnat
       ibg=(6.*widthG/srw+1.)/2.    ! 0.0005 precission
       ibg=2*ibg

       if(b_Gauss) then
        if(ibg.gt.mGa) ibg=mGa

        if(ibg.gt.0) then
c        -ibg--------0--------ibg           gauss

         width2=widthG/wln2/2.0   ! in units of gamma natural
         disp=srw/width2
         h0=-disp
         do i=0,ibg+1
          h0=h0+disp
          gauss(i)=exp(-h0**2)
         end do
          h1=0.
         do j=1,ibg-1,2
          h1=h1+ gauss(j)*2.
         end do
         do j=2,ibg-2,2
          h1=h1+ gauss(j)
         end do
         h1=(h1*2.+gauss(0)+gauss(ibg))
         h1=2.*h1/3.
         do i=0,ibg+1
          gauss(i)=gauss(i)/h1
         end do
         do i=0,ibg/2
          array_fr(iposGau+i)=cmplx(gauss(2*i),gauss(2*i+1))
         end do
        end if
       else
        do i=0,ibg/2
         gauss(2*i)=real(array_fr(iposGau+i))
         gauss(2*i+1)=aimag(array_fr(iposGau+i))
        end do
       end if    ! b_Gauss

       nLor=nLG+ibg
       relarea=1./(w_Lorentz+1.)
       widthL2=(w_Lorentz+1.)*gamnat/2.
       disp=srw/widthL2
       hp=-Eagd/widthL2-disp*float(nLor+1)

c       Lorentz curve  with stepwidth (srw)
c
c       0---------------------------------------nLor

        do  n=-nLor,nLor
         hp=hp+disp
         cLOR(n)=relarea/(1.0+hp*hp)*cmplx(hp,1.)
        end do

c        write(6,'(a)') 'cLOR(n)='
c        write(6,'(i4,2f12.3)') (n,cLOR(n)*100.,n=-5,5)

c       convolution with exp(-x**2/(sGgL*gamnat)**2)
c
c       0------------------------------------nLG---nLor
c                                     ibg----0----ibg
c       0------------------------------------nLG

c       this convolution is calculated with stepwidth srw8

c        write(6,'(a,i4)')  ' ####aLORGAU igb=',ibg
        if(ibg.gt.0) then
         do i=-nLG,nLG
          hc=(0.,0.)
          do j=-ibg+1,-1,2
            hc=hc+gauss(-j)*cLOR(i+j)*2.
          end do
          do j=1,ibg-1,2
           hc=hc+gauss(j)*cLOR(i+j)*2.
          end do
          do j=-ibg+2,-2,2
           hc=hc+gauss(-j)*cLOR(i+j)
          end do
          do j=0,ibg-2,2
           hc=hc+gauss(j)*cLOR(i+j)
          end do
          hc=hc*2.+gauss(ibg)*(cLOR(i-ibg)+cLOR(i+ibg))
          cLG(i)=hc/3.
         end do
        else
         do i=-nLG,nLG
          cLG(i)=cLOR(i)
         end do
        end if           ! if ibg >0

      end if
      return
      end



