      subroutine thstr_11indexmoss(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory

c     sad= source,absorber,detector : lstr1case=1,2,3      

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(4:4).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_11refindex  nameth_as=',nameth_as(:40)
      

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='scalar refraction index (sad)'                                    !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=1x1_ref_index_static_sad  scal,1 nc_v_a_the=3,2,t'
       else if(l_jth.eq.2) then
        property=
     & 'prop=1x1_ref_index_dynamic_sad  scal,1 nc_v_a_the=2,2,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=2    ! <=(max_nth
      nameth(1)='scalar refraction index (static,sad)'
      nameth(2)='scalar refraction index (dynamic,sad)'
      nameth(3)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=4     ! <=max_nth
       ntheory(1)='Mossbauer transmission_3'
       ntheory(2)='Mossbauer reemission_3'
       ntheory(3)='Mossbauer transmission_ext_3'
       ntheory(4)='Mossbauer reemission_ext_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk'.and.l_jth.eq.1) then
       nstruct='handbook=nucleus.hdb'//
     & 'list=3  seq=2 chth='//chth  
       return
      end if


      if(cmch.eq.'copa') then

       k=1
       do while(strco(k)(:5).ne.'#beg#')
        k=k+1
       end do
       j=k-1
       jb=k
       strco(j+1)='flag_SAMP               1    1 '
                 ! discrete (1) , continuous(0) LG-curves
       strco(j+2)='flag_Voigt              2    1'
                 ! LG-convolution (1) , Voigt profile (0)
       j=j+2            
       strco(j+1)='#end#  2   seq1'
       strco(j+2)='#beg#'
       do k=jb,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567      
       strtm(jm+1,1)='Intensity               ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2                  1     1  '
       jm=jm+1
       
       if(l_jth.eq.1) then
        strtm(jm+1,1)='isomer_shift            ,  1 1'
        strtm(jm+1,2)='isomer shift of the spectrum'
        strth(jh+2,1)='shift            , 0.0  0.0 0.0  0.1'
        strth(jh+2,2)='shift                   2     1 '
        jm=jm+1
       end if
  
       strtm(jm+1,1)='#end#  2 '
       strtm(jm+2,1)='#beg#'
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end
      

      subroutine thstr_11index(l_jth,cmch,property)
c     n_ik(E) refraction index (static) for
c     Mossbauer transmission , powder, anisotropic f-factor
c     level 3 theory
      
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(4:4).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_11refindexstrobo  nameth_as=',nameth_as(:40)
      

       b_return=cmch.eq.'name'
      if(b_return) 
     & property='scalar refraction index'                                !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=1x1_ref_index_static  scal,1 nc_v_a_the=1,2,t'
c       else if(l_jth.eq.2) then
c        property=
c     & 'prop=1x1_ref_index_dynamic  scal,1 nc_v_a_the=2,2,t'
       end if
       b_return=.true.
      end if
      
c     names of this routine
      mthchild=1    ! <=(max_nth
      nameth(1)='scalar refraction index (static)'
c      nameth(2)='scalar refraction index (dynamic)'
      nameth(2)=' '
      if(b_return) return
      
      
      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='stroboscopic transmission spectrum_3'
       ntheory(2)='stroboscopic reflection spectrum_3'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk'.and.l_jth.eq.1) then
       nstruct='handbook=nucleus.hdb'//
     & 'list=3  seq=2 chth='//chth  
       return
      end if

c           no ask (y)
c      #    ask [n]
c      #y   ask [y]
c      #i   intensity parameter no ask (y)
c      double ## := from data file
c      ##   from data file, ask [n]
c      ##y  from data file, ask [y]
c      ##n  from data file, no ask (y)


      if(cmch.eq.'copa') then

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
c        write(6,'(i4,a,a)')k,' strtm(k,1)=',strtm(k,1) 
        k=k+1
       end do
       jm=k-1
       jmb=jm+1
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c                     123456789012345678901234567      
       strtm(jm+1,1)='Intensity               ,#i 1 1'
       strtm(jm+1,2)='effective thickness by the f-factor at the site'
       strth(jh+1,1)='mg/cm2           , 1.0  0.0 0.0  0.1'
       strth(jh+1,2)='mg/cm2                  1     1  '
       jm=jm+1
       
       if(l_jth.eq.1) then
        strtm(jm+1,1)='isomer_shift            ,  1 1'
        strtm(jm+1,2)='isomer shift of the spectrum'
        strth(jh+2,1)='shift            , 0.0  0.0 0.0  0.1'
        strth(jh+2,2)='shift                   2     1 '
        jm=jm+1
       end if
  
       strtm(jm+1,1)='#end#  2 '
       strtm(jm+2,1)='#beg#'
        
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if

      return
      end
