      subroutine thstr_hdeq(l_jth,cmch,property)

c     hyperfine parameters of H(j),DEQ(j), equivalent sites
c     for n_ik(E) refraction index (static)
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(3:3).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_hdeq nameth_as=',nameth_as(:40)
 
      b_return=cmch.eq.'name'
      if(b_return)
     & property='22ref.index(stat)-H DEQ'                               !name
      if(cmch.eq.'prop') then
       property='prop=H_DEQ_equivalent_sites  plrs,1  nc_v_a_the=9,8,t'
       b_return=.true.
      end if

c     name of this routine
      mthchild=1       ! <=max_nth
      nameth(1)='H(j),DEQ(j), equivalent sites'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=2     ! <=max_nth
       ntheory(1)='2x2 refraction index (static,sad)'
       ntheory(2)='2x2 refraction index (static)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=5 seq=2  chth='//chth  
       return
      end if

      if(cmch.ne.'copa') return
      k=1
      do while(strco(k)(:5).ne.'#beg#')
c       write(6,'(a)') strco(k)
       k=k+1
      end do
      jc=k-1


      strco(jc+1)='Cnz_n                   1     1'
               ! equivalent sites by rotation around the z-axis
      strco(jc+2)='Cny_n                   2     1'
               ! equivalent sites by rotation around the y-axis
      strco(jc+3)='#end#     2  seq'
      strco(jc+4)='#beg#'

      do k=jc+1,jc+2
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do


c      common/avsstrf/avss,
c                      sftr,aisom,w_Gauss,w_Lorentz
c     &                sx2zz,sx2eta,sx2phi,sx2theta,sx2psi,
c     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE

      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1
c     write(6,'(a,4i4)') ' thstruct02  jm,jh=',jm,jh

c                    123456789012345678901234567      
      strtm(jm+1,1)='H_internal              ,# 3 3'
      strtm(jm+1,2)='internal magnetic field at crystal site'
      strth(jh+1,1)='Hi               , 333.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaH           , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='phiH             , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='Hi                      1    1 0 0  '
      strth(jh+2,2)='thetaH                  2    0 1 0 '
      strth(jh+3,2)='phiH                    3    0 0 1'

      strtm(jm+2,1)='EFG                     ,# 2 2'
      strtm(jm+2,2)='electric field gradient tensor at crystal site'
      strth(jh+4,1)='EFG              , 0.0  0.0 0.0  0.1'
      strth(jh+5,1)='eta              , 0.0  0.0 0.0  0.1'
      strth(jh+4,2)='EFG                     4    1 0 '
      strth(jh+5,2)='eta                     5     0 1 '
      jm=jm+2
      jh=jh+5
      strtm(jm+1,1)='orient_EFG                # 3 3'
      strtm(jm+1,2)='Euler angle of the EFG in the crystal system'
      strth(jh+1,1)='phiE            , 0.0  0.0 0.0  1.0'
      strth(jh+2,1)='thetaE          , 0.0 0.0 0.0   1.0'
      strth(jh+3,1)='psiE            , 0.0 0.0 0.0   1.0 '
      strth(jh+1,2)='phiE                    6   1 0 0'
      strth(jh+2,2)='thetaE                  7   0 1 0'
      strth(jh+3,2)='psiE                    8   0 0 1 '
      jm=jm+1
      jh=jh+3

      strtm(jm+1,1)='#end#  8'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      return
      end


      subroutine thstr_hdeqf(l_jth,cmch,property)

c     hyperfine parameters of H(j),DEQ(j), equivalent sites
c     for n_ik(E) refraction index (static), 
c     powder,texture and external field
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(3:3).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_hdeqf nameth_as=',nameth_as(:40)
 

      b_return=cmch.eq.'name'
      if(b_return)
     & property='22ref.index(stat)-H DEQ f'                             !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) then
        property=
     & 'prop=H_DEQ_f_equivalent_sites  plrs,1  nc_v_a_the=9,13,t'
       else if(l_jth.eq.2)then 
        property=
     & 'prop=H_DEQ_f_equivalent_sites  plrs,2  nc_v_a_the=9,13,t'
       end if
       b_return=.true.
      end if

c     name of this routine
      mthchild=2       ! <=max_nth
      nameth(1)='H(S_E),DEQ,f(S_C), equiv. sites'  ! H in S_efg      
      nameth(2)='H(S_C),DEQ,f(S_C), equiv. sites'  ! H in S_C
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='2x2 refraction index (static,f_anisotrop,sad)'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb'//
     & ' list=5 seq=2  chth='//chth  
       return
      end if

      if(cmch.eq.'copa') then
       k=1
       do while(strco(k)(:5).ne.'#beg#')
c        write(6,'(a)') strco(k)
        k=k+1
       end do
       jc=k-1
c       write(6,'(a,4i4)') ' hdeqf  jc=',jc
c                   123456789012345678901234567      
       strco(jc+1)='sym_case                1     0'
               ! equivalent sites by rotation around the z-axis
       strco(jc+2)='time_invers             2     111111'
               ! equivalent sites by rotation around the y-axis
       strco(jc+3)='#end#     2  seq=1'
       strco(jc+4)='#beg#'

       do k=jc+1,jc+2
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
       end do

c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,
c     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
c                     123456789012345678901234567      
       strtm(jm+1,1)='x2sanisotropy            ,# 2 2'
       strtm(jm+1,2)='mean square <x2> at the site'
       strth(jh+1,1)='dsx2                  ,  0.0  0.0 0.0  0.1'
       strth(jh+2,1)='x2seta                ,  0.0  0.0 0.0  0.1'
       strth(jh+1,2)='dsx2                     1    1 0  '
       strth(jh+2,2)='x2seta                   2    0 1  '

       strtm(jm+2,1)='x2sorientation           ,# 3 3'
       strtm(jm+2,2)='<x2> orientation with respect to S_C for'
       strth(jh+3,1)='x2sphi                , 0.0  0.0 0.0  1.0'
       strth(jh+4,1)='x2stheta              , 0.0  0.0 0.0  1.0'
       strth(jh+5,1)='x2spsi                , 0.0  0.0 0.0  1.0'
       strth(jh+3,2)='x2sphi                   3    1 0 0 '
       strth(jh+4,2)='x2stheta                 4    0 1 0 '
       strth(jh+5,2)='x2spsi                   5    0 0 1 '

       strtm(jm+3,1)='H_internal              ,# 3 3'
       strtm(jm+3,2)='internal magnetic field at crystal site'
       strth(jh+6,1)='Hi               , 333.0  0.0 0.0  1.0'
       strth(jh+7,1)='thetaH           , 0.0 0.0 0.0   1.0'
       strth(jh+8,1)='phiH             , 0.0 0.0 0.0   1.0 '
       strth(jh+6,2)='Hi                       6    1 0 0  '
       strth(jh+7,2)='thetaH                   7    0 1 0 '
       strth(jh+8,2)='phiH                     8    0 0 1'
       jm=jm+3
       jh=jh+8
       strtm(jm+1,1)='EFG                     ,# 2 2'
       strtm(jm+1,2)='electric field gradient tensor at crystal site'
       strth(jh+1,1)='EFG              , 0.0  0.0 0.0  0.1'
       strth(jh+2,1)='eta              , 0.0  0.0 0.0  0.1'
       strth(jh+1,2)='EFG                      9     1 0 '
       strth(jh+2,2)='eta                      10    0 1 '
       jm=jm+1
       jh=jh+2
  
c                     123456789012345678901234567      
       strtm(jm+1,1)='orient_EFG               # 3 3'
       strtm(jm+1,2)='Euler angle of the EFG in the crystal system'
       strth(jh+1,1)='phiE            , 0.0  0.0 0.0  1.0'
       strth(jh+2,1)='thetaE          , 0.0 0.0 0.0   1.0'
       strth(jh+3,1)='psiE            , 0.0 0.0 0.0   1.0 '
       strth(jh+1,2)='phiE                    11   1 0 0'
       strth(jh+2,2)='thetaE                  12   0 1 0'
       strth(jh+3,2)='psiE                    13   0 0 1'
       jm=jm+1
       jh=jh+3
  
  
       strtm(jm+1,1)='#end#  13'
       strtm(jm+2,1)='#beg#'
  
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
       return
      end if

      return
      end


