      subroutine thstr_synsource(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for' 

      character property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synsource  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Synchrotron source (distribute)'                        !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=0,0,0'
      end if

c     name of this routine
      mthchild=2
      nameth(1)='Nuclear forward scattering'
      nameth(2)='X-ray specular reflection'      
      nameth(3)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='Synchrotron source'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      return
      end

      subroutine thstr_syntransmission(l_jth,cmch,property)
c     time domain spectrum for synchrotron transmission
c     level 0 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)

      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_syntransmission  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='Nuclear forward scattering (distribute)'                         !name
      if(cmch.eq.'prop') then
       property='prop=nocall       nono,0   nc_v_a_the=14,1,0 '
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='time differential transmission spectrum'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=max_nth
       ntheory(1)='Nuclear forward scattering'
       do k= 1,mthparent
        if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=1  seq=2 chth='//chth
       return
      end if

      if(cmch.eq.'copa') then
       j=1
       do while(strco(j)(:5).ne.'#beg#')
        j=j+1
       end do
       j=j-1
       jc=j+1
      
c      common/acstrf/ acsp,wavelength,uthick,            
c     &               unit_chi,                                        1
c     &               aiT_max,v_max,ak_extension,                      4
c     &               T_bunch,scale,                                   6
c     &               channels,ch_angle,graz_beg,graz_end,            10
c     &               t0_norm,flag_basis                              12

       strco(j+1)='i_T_max                 2     0 '
                ! Time window for display
       strco(j+2)='v_max [mm/s]            3     8 '
                ! v_max of the nuclear energies
       strco(j+3)='k_extension 2**k        4     0 '
                ! times v_max
       j=j+3
       strco(j+1)='T0_NormInt              11    10'
                 ! integration for normalizing from t0
       strco(j+2)='T_bunch                 5    ## y 160'
                 ! bunch distance in ns
       strco(j+3)='nu_channels             7    ##n 256'
                ! number of channels for for angles
       strco(j+4)='scale                   6    ## y 1'
                ! determines function for channel to time conversion
       strco(j+5)='flag_basis              12     1 '
                 ! switch for circular-linear basis 
       j=j+5
       strco(j+1)='#end#  12  seq1'
       strco(j+2) ='#beg#'

       do k=jc,j
        ch132=strco(k)
        call stringlength(ch132,l)
        strco(k)=ch132(:l)//'/'//chth
c        write(6,'(a)') strco(k)(:80)
       end do

       k=1
       do while(strtm(k,1)(:5).ne.'#beg#')
        k=k+1
       end do
       jm=k-1
       jmb=k
       k=1
       do while(strth(k,1)(:5).ne.' ')
        k=k+1
       end do
       jh=k-1
        
c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      t_shif
        
        strtm(jm+1,1)='calibration               ,## y 1 1'
        strtm(jm+1,2)='frame parameter t_shift'
        strth(jh+1,1)='t_shift           , 0.0 0.0 0.0 0.1'
        strth(jh+1,2)='t_shift                 1     1  '
        
        strtm(jm+2,1)='#end#    1 '
        strtm(jm+3,1)='#beg#'
        jm=jm+3
       do k=jmb,jm
        ch132=strtm(k,1)
        call stringlength(ch132,l)
        strtm(k,1)=ch132(:l)//'/'//chth
       end do
      end if
      return
      end

      subroutine thstr_synreflection(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='X-ray specular reflection (distribute)'                 !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) 
     & property='prop=nocall       nono,0   nc_v_a_the=16,3,0'
       if(l_jth.eq.2)
     & property='prop=nocall       nono,0   nc_v_a_the=16,3,0'
       if(l_jth.eq.3)
     & property='prop=nocall       nono,0   nc_v_a_the=16,3,0'
       if(l_jth.eq.4) 
     & property='prop=nocall       nono,0   nc_v_a_the=16,5,0'
       b_return=.true.
      end if

c     name of this routine
      mthchild=4
      nameth(1)='time differential reflection spectrum'
      nameth(2)='time integral - rocking curve(Fourier)'
      nameth(3)='time integral - rocking curve'
      nameth(4)='prompt - rocking curve'
      nameth(5)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='X-ray specular reflection'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=2  seq=2 chth='//chth
       return
      end if 

      if(cmch.ne.'copa') return
      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1

c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,                               3
c     &              ak_extension,T_bunch,scale,channels,                  7
c     &              ch_angle,graz_beg,graz_end,t0_norm,flag_basis,        12
c     &              th_channels,th_sampling,                              14
c     &              strob_order,t1_window,t2_window,dumcsp(icstrf-20)


c                  1                  012345
      if(l_jth.eq.3) then
       strco(j+1)='v_max [mm/s]            3    25 '
                ! v_max of the nuclear energies
       strco(j+2)='th_channels            13    126'
                ! 2**th_sampling <=8 ; 1 means maximal accuracy 
       strco(j+3)='th_sampling            14     3 '
                ! 2**th_sampling <=8 ; 1 means maximal accuracy 
       strco(j+4)='T_bunch                 5  ## y 176'
                 ! bunch distance in ns
       j=j+4
      end if

      if(l_jth.le.2) then
       strco(j+1)='i_T_max                 2     0 '
                ! Time window for calculation
       strco(j+2)='v_max [mm/s]            3     8 '
                ! v_max of the nuclear energies
       strco(j+3)='k_extension 2**k        4     0 '
                ! times v_max
       j=j+3
      end if
      if(l_jth.ge.2) then
       strco(j+1)='nu_angle                 8       128 '
       strco(j+2)='graz_begin               9    ## 3  '
       strco(j+3)='graz_end                10    ## 20 '
       strco(j+4)='nu_channels              7    ##n 128 '
                ! number of channels for  angles
       j=j+4
      end if
      if(l_jth.eq.2) then
       strco(j+1)='T0_Integral             11    10'
                 ! integration probability of delayed events from t0
       strco(j+2)='T_bunch                 5  ## y 176'
                 ! bunch distance in ns
       j=j+2
      end if
      if(l_jth.eq.1) then
       strco(j+1)='T0_NormInt              11    10'
                 ! integration for normalizing from t0
       strco(j+2)='T_bunch                 5    ## y 160'
                 ! bunch distance in ns
       strco(j+3)='nu_channels             7    ##n 256'
                ! number of channels for for angles
       j=j+3
      end if
      if(l_jth.le.3) then
       strco(j+1)='flag_basis              12     1 '
                 ! switch for circular-linear basis 
       j=j+1
      end if
      strco(j+1)='scale                   6    ## y 1'
                ! determines function for channel to time conversion

      strco(j+2)='unit_chi                1     1.0e-6 '
                ! susceptibility multiplied by
      j=j+2

      strco(j+1)='#end#  14  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do


      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      ang_shift(t_shift),graz_angle(graz_min),phi_z,
c                      detekt_eff,counts_bunch

c                    1                  012345
      if(l_jth.eq.1) then
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter t_shift'
       strth(jh+1,1)='t_shift           , 0.0 0.0 0.0 0.1'
       strth(jh+1,2)='t_shift                  1     1  '

       strtm(jm+2,1)='orientation                ## y 2 2'
       strtm(jm+2,2)='(2) grazing angle of the scatterer'
       strth(jh+2,1)='graz_angle        , 5.0 0.0 0.0   1.0'
       strth(jh+3,1)='phi_z             , 0.0  0.0 0.0  1.0'
       strth(jh+2,2)='graz_angle                2    1 0 '
       strth(jh+3,2)='phi_z                     3    0 1 '
       jm=jm+2
       jh=jh+3
      end if

      if(l_jth.gt.1) then
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter angle shift'
       strth(jh+1,1)='ang_shift           0.0 0.0 0.0 0.1'
       strth(jh+1,2)='ang_shift               1     1  '

       strtm(jm+2,1)='orientation                ##  y 2 2'
       strtm(jm+2,2)='phi_z, graz_min of the scatterer plane'
       strth(jh+2,1)='graz_min            1.0  0.0 0.0  0.01'
       strth(jh+3,1)='phi_z               0.0  0.0 0.0  1.0'
       strth(jh+2,2)='graz_min                  2    1 0'
       strth(jh+3,2)='phi_z                     3    0 1'
       jm=jm+2
       jh=jh+3
      end if
      strtm(jm+1,1)='#end#    3  seq'

      if(l_jth.eq.4) then
       strtm(jm+1,1)='deadtime                 ,## y 2 2'
       strtm(jm+1,2)='frame parameter detekt_eff,counts_bunch'
       strth(jh+1,1)='detekt_eff             , 0.9 0.0 0.0 0.1'
       strth(jh+2,1)='counts_bunch           , 1.0 0.0 0.0 0.1'
       strth(jh+1,2)='detekt_eff                4     1 0 '
       strth(jh+2,2)='counts_bunch              5     0 1 '
       jm=jm+1
       strtm(jm+1,1)='#end#    5  seq'
      end if
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end


      subroutine thstr_synreflectionoffspec(l_jth,cmch,property)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character ch132*132,property*132,chth*8,cmch*4
      logical b_return

      chth='th'//property(1:6)


      if(enwr(14)(1:1).eq.'y') write(nwr,'(2(a,a8),a,i2,a,/,a)')
     & ' cmch=',cmch,' thstruct:',chth,' l_jth=',l_jth,
     & ' subr= thstr_synreflection  nameth_as=',nameth_as(:40)

      b_return=cmch.eq.'name'
      if(b_return)
     & property='X-ray offspecular reflection (distribute)'                      !name
      if(cmch.eq.'prop') then
       if(l_jth.eq.1) 
     & property='prop=nocall       nono,0   nc_v_a_the=14,1,0'
       b_return=.true.
      end if

c     name of this routine
      mthchild=1
      nameth(1)='offspecular'
      nameth(2)=' '
      if(b_return) return

      if(l_jth.eq.0) then
c      asking for the number (mthchild) of theories fitting to ntheory
       mthparent=1     ! <=(max_nth
       ntheory(1)='X-ray offspecular reflection'
       do k= 1,mthparent
         if(nameth_as.eq.ntheory(k)) l_jth=mthchild
       end do
       return
      end if

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb '//
     &        'list=2  seq=2 chth='//chth
       return
      end if 


      if(cmch.ne.'copa') return
      j=1
      do while(strco(j)(:5).ne.'#beg#')
       j=j+1
      end do
      j=j-1
      jc=j+1


c      common/acstrf/ acsp,wavelength,uthick,            
c     &               unit_chi,                                        1
c     &               aiT_max,v_max,ak_extension,                      4
c     &               T_bunch,scale,                                   6
c     &               channels,ch_angle,graz_beg,graz_end,            10
c     &               t0_norm                                         11

c                  1                  012345
       strco(j+1)='i_T_max                 2     0 '
                ! Time window for display
       strco(j+2)='v_max [mm/s]            3     8 '
                ! v_max of the nuclear energies
       strco(j+3)='k_extension 2**k        4     0 '
                ! times v_max
       j=j+3
       strco(j+1)='nu_angle                 8       128 '
       strco(j+2)='theta1[mrad]             9    ##  15  '
       strco(j+3)='theta2_begin            10    ##  10 '
       strco(j+4)='theta2_end              11    ##  20 '
       strco(j+5)='nu_channels              7    ##n 128 '
                ! number of channels for for angles
       j=j+4
       strco(j+1)='T0_Integral             12    10'
                 ! integration probability of delayed events from t0
       strco(j+2)='T_bunch                  5  ## y 160'
                 ! bunch distance in ns
       j=j+2
      strco(j+1)='scale                    6    ## y 1'
                ! determines function for channel to time conversion

      strco(j+2)='unit_chi                1     1.0e-6 '
                ! susceptibility multiplied by
      j=j+2

      strco(j+1)='#end#  12  seq1'
      strco(j+2)='#beg#'

      do k=jc,j
       ch132=strco(k)
       call stringlength(ch132,l)
       strco(k)=ch132(:l)//'/'//chth
c       write(6,'(a)') strco(k)(:80)
      end do



      k=1
      do while(strtm(k,1)(:5).ne.'#beg#')
       k=k+1
      end do
      jm=k-1
      jmb=k
      k=1
      do while(strth(k,1)(:5).ne.' ')
       k=k+1
      end do
      jh=k-1

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      ang_shift(t_shift)

c                    1                  012345
       strtm(jm+1,1)='calibration               ,## y 1 1'
       strtm(jm+1,2)='frame parameter angle shift'
       strth(jh+1,1)='ang_shift           0.0 0.0 0.0 0.1'
       strth(jh+1,2)='ang_shift               1     1  '

       jm=jm+1
       jh=jh+1
      strtm(jm+1,1)='#end#    1  seq'
      strtm(jm+2,1)='#beg#'

      do k=jmb,jm
       ch132=strtm(k,1)
       call stringlength(ch132,l)
       strtm(k,1)=ch132(:l)//'/'//chth
      end do

      property=nameth(l_jth)
      return
      end

