      subroutine jacobihf(mj,j,Hm,EE,Evec,NN,A,D,V)
      parameter (OUTJ=100000.)
      DIMENSION D(NN),EE(-mj:mj)
      complex Hm(-mj:mj,-mj:mj),Evec(-mj:mj,-mj:mj),
     &        A(NN,NN),V(NN,NN)


      m=0
      do i=j,-j,-2
       m=m+1
       A(m,m)=Hm(i,i)
      end do

      n=0
      do k=j,-j+2,-2
       n=n+1
       m=n
       do i=k-2,-j,-2
       m=m+1
        A(n,m)=Hm(k,i)
c       write(6,'(2i4,2f10.3)')n,m,A(n,m)
       end do
      end do
      
      call jaccmplx(NN,OUTJ,A,D,V,nrot)

       m=0
       do i=j,-j,-2
       m=m+1
       EE(i)=D(m)
        n=0
        do k=j,-j,-2
         n=n+1
         Evec(i,k)=conjg(V(n,m))
c        write(6,'(2i4,2f10.3)')n,m,V(n,m)
        end do
       end do

c     eigenstates are |J>= Sum; i U(iJ)*|i>  ;  Evec=U+
c     U+HU is diagonal
c     <I|H|J> = Sum; i,k conjg(U(kI))*U(ij)*<k|H|i>
c     <I|H|J> = Sum; i,k U(Ik)+*<k|H|i>*U(iJ)
c     <I|H|J> = Sum; i,k Evec(I,k)*<k|H|i>*Evec(i,J)+

      return
      end


      subroutine jaccmplx(N,OUTJ,A,ED,V,nrot)
      complex A(N,N),V(N,N),epsi,
     &        upp,upq,uqp,uqq,cupp,cupq,cuqp,cuqq,
     &        Apq,Arp,Arq,Apr,Aqr,Vrp,Vrq
      dimension ED(N)

      dsq2=1./sqrt(2.)

      do ip=1,N
      do iq=1,N
        V(iq,ip)=(0.,0.)
      end do
      end do
      do ip=1,N
        ED(ip)=real(A(ip,ip))
        V(ip,ip)=(1.,0.)
      end do
                
      sd=1.0
      nrot=0
      do is=1,50                      ! sweep
        nrot=nrot+1
        if(sd.eq.0.) goto 1000
        sd=0.
        do ip=1,N-1
          do iq=ip+1,N
            Apq=A(ip,iq)
            Apqi=aimag(Apq)
            Apqr=real(Apq)
            hOUTr=OUTJ*abs(Apqr)     ! out condition
            hOUTi=OUTJ*abs(Apqi)     ! out condition
            hOUT=hOUTr+hOUTi
            Dp=ED(ip)
            Dq=ED(iq)
            hd=Dq-Dp
            abshd=abs(hd)
            if(abshd.lt.hOUT) then
              if(abshd.gt.hOUTr) then
                epsi=cmplx(dsq2,-sign(dsq2,Apqi))
                Apqb=abs(Apqi)
               goto 100
              end if !      real part =0
              if(abshd.gt.hOUTi) then
                epsi=cmplx(1.,0.)
                Apqb=Apqr
               goto 100
              end if ! imaginary part =0
                Apqb=sqrt(Apqr**2+Apqi**2)
                cosa=(1.+Apqr/Apqb)/2.
                if(cosa.lt.1.e-6) then
                 epsi=-cmplx(0.0,sign(1.,Apqi))
                else
                 cosa=sqrt(cosa)
                 epsi=cmplx(cosa,-Apqi/Apqb/2./cosa)
                end if
  100         continue

            if(abs(Apqb).gt.0.) then
             sd=sd+hOUT
             x=hd/Apqb
              if(abs(x).gt.64) then
                sc=1.0-0.5/x**2
                ss=sc/x
              else
                x=(x+sqrt(4.+x**2)*sign(1.,x))/2.
                hi=1.+x**2
                hj=sqrt(hi)*sign(1.,x)
                sc=1.0-1.0/(hi+hj*x)
                ss=1.0/hj
              end if                  ! abs(hd) .gt. OUTJ*|A(p,q)|
              upp=sc*epsi
              upq=-ss*conjg(epsi)
              uqp=-conjg(upq)
              uqq=conjg(upp)
              cupp=uqq
              cupq=conjg(upq)
              cuqp=conjg(uqp)
              cuqq=upp

              hd2=Apqb/x
              ED(ip)=Dp-hd2
              ED(iq)=Dq+hd2
              A(ip,iq)=cmplx(0.,0.)

              do ir=1,ip-1
                Arp=A(ir,ip)
                Arq=A(ir,iq)
                A(ir,ip)=Arp*cupp+Arq*cupq
                A(ir,iq)=Arp*cuqp+Arq*cuqq
              end do                   ! ir=1,ip-1
              do ir=ip+1,iq-1
                Apr=A(ip,ir)
                Arq=A(ir,iq)
                A(ip,ir)=upp*Apr+upq*conjg(Arq)
                A(ir,iq)=conjg(uqp*Apr)+cuqq*Arq
              end do                   ! ir=ip+1,iq-1
              do ir=iq+1,N
                Apr=A(ip,ir)
                Aqr=A(iq,ir)
                A(ip,ir)=upp*Apr+upq*Aqr
                A(iq,ir)=uqp*Apr+uqq*Aqr
              end do                   ! ir=iq+1,N
              do ir=1,N
                Vrp=V(ir,ip)
                Vrq=V(ir,iq)
                V(ir,ip)=Vrp*cupp+Vrq*cupq
                V(ir,iq)=Vrp*cuqp+Vrq*cuqq
              end do                   ! ir=1,N
c       write(6,'(8f10.3)')((V(ii,jj),ii=1,N),jj=1,N)
c       read(5,'(a)')
             end if                    ! Apq>0
            end if                     ! abs(hd).gt. OUTJ*|A(p,q)|
          end do                       ! iq=ip+1,N
        end do                         ! ip=1,N-1
c       write(6,'(8f10.3)')((A(ip,iq),iq=1,N),ip=1,N)
c       read(5,'(a)')
      end do                           ! sweeps
 1000 continue                         ! out
      return
      end


      subroutine dewigh(j,beta,dd)
c     half integral spin j/2
      dimension dd(-5:5,-5:5)

      beth=beta/2.0
      c=cos(beth)
      s=sin(beth)
      c2=c*c
      c3=c2*c
      c4=c3*c
      c5=c4*c
      s2=s*s
      s3=s2*s
      s4=s3*s
      s5=s4*s
      w2=sqrt(2.0)
      w3=sqrt(3.0)
      w5=sqrt(5.0)
      w10=sqrt(10.0)

      if (j.eq.1) then
      dd(1,1)=c
      dd(1,-1)=-s
      end if

      if (j.eq.3) then
      dd(3,3)  =c3

              h=-w3*c2*s
      dd(3,1)  =h
      dd(-3,-1)=-h
      dd(-1,-3)= h
      dd(1,3)  =-h

             h=w3*c*s2
      dd(3,-1)=h
      dd(1,-3)=h
      dd(-3,1)=h
      dd(-1,3)=h

      dd(3,-3)=-s3

      dd(1,1)=c*(3.0*c2-2.0)
      dd(1,-1)=s*(3.0*s2-2)
      end if

      if (j.eq.5) then

      dd(5,5)  = c5
      dd(-5,-5)= c5

             h = -w5*c4*s
      dd(5,3)  = h
      dd(-5,-3)=-h
      dd(3,5)  =-h
      dd(-3,-5)= h

             h = w10*c3*s2
      dd(5,1)  = h
      dd(1,5)  = h
      dd(-5,-1)= h
      dd(-1,-5)= h

             h = -w10*c2*s3
      dd(5,-1) = h
      dd(-5,1) =-h
      dd(-1,5) =-h
      dd(1,-5) = h

             h = w5*c*s4
      dd(5,-3) = h
      dd(-5,3) = h
      dd(3,-5) = h
      dd(-3,5) = h

      dd(5,-5) =-s5
      dd(-5,5) = s5

      dd(3,3)  = c5-4.0*c3*s2

             h = 3.0*w2*c3*s2-2.0*w2*c*s4
      dd(3,-1) = h
      dd(1,-3) = h
      dd(-3,1) = h
      dd(-1,3) = h

            h = 3.0*w2*c2*s3-2.0*w2*c4*s
      dd(3,1) = h
      dd(-3,-1) =-h
      dd(-1,-3) = h
      dd(1,3)   =-h

      dd(3,-3)=s5-4.0*c2*s3

      dd(1,1)=c5-6.0*c3*s2+3.0*c*s4
      dd(1,-1)=-s5+6.0*c2*s3-3.0*c4*s

      end if

      dd(-3,-3)= dd(3,3)
      dd(-3,3)=-dd(3,-3)

      dd(-1,-1)=dd(1,1)
      dd(-1,1)=-dd(1,-1)

      return
      end         !   Ende Procedure Dewigner(halbzahlig)



      function clebsch(a,am,b,bm,c,cm)

c this function calculates the Clebsch Gordan coefficients
c     C(a,b,am,bm/c,cm)
      real clebsch
      double precision fac,del,w,sum

      if(abs(am).gt.a) goto 12
      if(abs(bm).gt.b) goto 12
      if(abs(cm).gt.c) goto 12
      if(a+b.lt.c) goto 12
      if(a+c.lt.b) goto 12
      if(b+c.lt.a) goto 12
      if(am+bm.ne.cm) goto 12
      del=fac(a+b-c)*fac(a+c-b)*fac(b+c-a)/fac(a+b+c+1.)
        w=fac(a+am)*fac(a-am)*fac(b+bm)*fac(b-bm)*
     &      fac(c+cm)*fac(c-cm)
        w=dsqrt(w*del)

      sum=0.d0
        hi=-1.
       do 9 ii=1,40
        hi=hi+1.
       h1=a-am-hi
      if(h1.lt.0) goto 10
       h2=b+bm-hi
      if(h2.lt.0) goto 10
       h3=a+b-c-hi
      if(h3.lt.0) goto 10
       h4=c-b+am+hi
      if(h4.lt.0) goto 9
       h5=c-a-bm+hi
      if(h5.lt.0) goto 9
      i=mod(ii-1,2)
      sum=sum+(-1.d0)**i/(fac(h1)*fac(h2)*fac(h3)*
     &        fac(h4)*fac(h5)*fac(hi))
  9   continue
 10   clebsch=sngl(w*sum)*sqrt(2.*c+1.)
      return
 12   clebsch=0.0
      return
      end



      function fac(x)
c     this function camculates the faculty up to 18
      double precision fac,f
      dimension f(19)

      data f/1.d0,1.d0,2.d0,6.d0,24.d0,120.d0,720.d0,5040.d0,
     &       40320.d0,362880.d0,36288.d2,  399168.d2,4790016.d2,
     &       62270208.d2,87178291.d3,1307674365.d3,2092278984.d4,
     &       35568742728.d4,640237369104.d4/
      n=x
      if(n.lt.0) stop
      fac=f(n+1)
      return
      end


      function wi3j(a,b,c,am,bm,cm)
       i=a-b-cm
       i=mod(i,2)
       wi3j=clebsch(a,am,b,bm,c,-cm)/sqrt(2.*c+1.)*(-1.)**i
      return
      end



         subroutine dewigner(j,bet,dd)

         dimension dd(-5:5,-5:5)

         c=cos(bet)
         s=sin(bet)
         cp=1.0+c
         cm=1.0-c
         sq2=sqrt(2.)

         if (j.eq.0) dd(0,0)=1.

         if (j.eq.1) then
         dd(1,1) =cos(bet/2.)**2
         dd(1,-1)=sin(bet/2.)**2
         dd(1,0) =-s/sq2
         dd(0,0) =c
         end if

         if (j.eq.2) then
         sq6=sqrt(6.0)/2.0
         dd(2,2) = cp**2/4.0
         dd(2,-2)= cm**2/4.0
         dd(2,1) = -s*cp/2.0
         dd(2,-1)= -s*cm/2.0
         dd(2,0) = sq6/2.0*s**2
         dd(1,1) = cp*(2.0*c-1.0)/2.0
         dd(1,-1)= cm*(2.*c+1.)/2.
         dd(1,0) = -sq6*s*c
         dd(0,0) = (3.*c**2-1.)/2.
        end if

         if (j.eq.4) then
         sq5=sqrt(5.)
         sq7=sqrt(7.)
         cp2=cp**2
         cp3=cp2*cp
         cm2=cm**2
         cm3=cm2*cm
         dd(4,4) =cp*cp3/16.
         dd(4,-4)=cm*cm3/16.
         h=sq2/8.*s
         dd(4,3) =-h*cp3
         dd(4,-3)=-h*cm3
         h=sq7/8.*s**2
         dd(4,2) =h*cp2
         dd(4,-2)=h*cm2
         h=h*s*sq2
         dd(4,1) =-h*cp
         dd(4,-1)=-h*cm
         dd(4,0) =h*s*sq5/2.
         dd(3,3) =cp3/8.*(4.*c-3.)
         dd(3,-3)=cm3/8.*(4.*c+3.)
         h=sq7*s/8.
         dd(3,2) =-h*sq2*cp2*(2.*c-1.)
         dd(3,-2)=-h*sq2*cm2*(2.*c+1.)
         h=h*s
         dd(3,1) =h*cp*(4.*c-1.)
         dd(3,-1)=h*cm*(4.*c+1.)
         dd(3,0) =-h*sq5*2.*s*c
         c2=c**2
         dd(2,2) =cp2/4.*(7.*(c2-c)+1.)
         dd(2,-2)=cm2/4.*(7.*(c2+c)+1.)
         h=sq2/8.*s
         dd(2,1) =-h*cp*(7.*(2.*c2-c)-1.)
         dd(2,-1)=-h*cm*(7.*(2.*c2+c)-1.)
         dd(2,0) =h*sq5*s*(7.*c2-1.)
         dd(1,1) =cp/8.*(c*(28.*c2-6.)-21.*c2+3.)
         dd(1,-1)=cm/8.*(c*(28.*c2-6.)+21.*c2-3.)
         dd(1,0) =-sq5/4.*s*c*(7.*c2-3.)
         dd(0,0) =(c2*(35.*c2-30.)+3.)/8.
        end if

c        point mirror at index (0,0)
         do mpt=j,1,-1
         do m=mpt,-mpt,-1
          l=mod(mpt-m,2)
          dd(-mpt,-m)=dd(mpt,m)*(-1)**l
         end do
         end do

c        diagonal mirror - indices (m,m)
         do mpt=-1,-j,-1
         do m=-mpt-1,mpt+1,-1
          l=mod(mpt-m,2)
          dd(m,mpt)=dd(mpt,m)*(-1)**l
         end do
         end do
         do mpt=j,1,-1
         do m=mpt-1,-mpt+1,-1
          l=mod(mpt-m,2)
          dd(m,mpt)=dd(mpt,m)*(-1)**l
         end do
         end do

        return
        end


c************************************************************************
       subroutine expo_22(x11,x12,x21,a)
       complex x11,x12,x21,d,expd,expdi,shd,chd,a(4)
c      traceless matrix exp(m(x11,x12,x21))= ch(d)+1/d*sh(d)*m
c      d=sqrt(x11**2+x21*x12)

       d=x11**2+x12*x21
       d=sqrt(d)
       absd=real(d)
       expd=exp(d)/2.
       expdi=0.25/expd
       if(abs(absd).gt.1.e-7) then
        shd=(expd-expdi)/d
        chd=expd+expdi
        a(1)=chd+shd*x11
        a(4)=chd-shd*x11
        a(2)=shd*x12
        a(3)=shd*x21
       else
        chd=(1.,0.)
        a(1)=chd+x11
        a(4)=chd-x11
        a(2)=x12
        a(3)=x21
       end if
       return
       end

       subroutine matpro(a,b,c)
       complex a(4),b(4),c(4)
        c(1)=a(1)*b(1)+a(2)*b(3)
        c(2)=a(1)*b(2)+a(2)*b(4)
        c(3)=a(3)*b(1)+a(4)*b(3)
        c(4)=a(3)*b(2)+a(4)*b(4)
       return
       end

C  *****************************************************************
C
C                 Fourier-transformation
C                   (fortran recipies)
C                   changed to complex
C                transform of 4 arrays (l=1-4)
C                          6.6.97
C  *****************************************************************
C
      subroutine fourier4(DATA,NN,mFF,ISIGN)
      real*8 THETA
      complex DATA(mFF)
      complex ww,wwp,temp
C
      N=2*NN
      J=1
C
      do 11 I=1,N,2
        if(J.gt.I)then
          jj=2*(J-1)
          ii=2*(I-1)
          do l=1,4
           temp=DATA(jj+l)
           DATA(jj+l)=DATA(ii+l)
           DATA(ii+l)=temp
          end do
        endif
        M=N/2
1       if ((M.ge.2).and.(J.gt.M)) then
          J=J-M
          M=M/2
        go to 1
        endif
        J=J+M
11    continue
C
      MMAX=2
2     if (N.gt.MMAX) then
        ISTEP=2*MMAX
        THETA=6.28318530717959D0/(ISIGN*MMAX)
        wwp=cmplx(1.D0-2.D0*dsin(0.5D0*THETA)**2,dsin(THETA))
        ww=cmplx(1.0,0.0)
        do 13 M=1,MMAX,2
          do 12 I=M,N,ISTEP
           ii=2*(I-1)
           jj=ii+ISTEP
           do l=1,4
            temp=ww*DATA(jj+l)
            DATA(jj+l)=DATA(ii+l)-temp
            DATA(ii+l)=DATA(ii+l)+temp
           end do
12        continue
          ww=wwp*ww
13      continue
        MMAX=ISTEP
      go to 2
      endif
      return
      end

      SUBROUTINE INDEXX(N,ARRIN,INDX)
      DIMENSION ARRIN(N),INDX(N)
      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=ARRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=ARRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(ARRIN(INDX(J)).LT.ARRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.ARRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END

      subroutine symbol3j(aje,La,ajg)
      implicit none
      include 'comnuc.for'
      real dif,aje,ajg,hLJe,em,gm,clebsch
      integer je,La,jg,i,j,M,jj,mj
      dif=abs(a_jg-ajg)+abs(a_je-aje)+abs(Lp-La)

      if(dif.gt.0.1) then
       jj=(jge/2)*2
       Lp=La
       a_jg=ajg
       a_je=aje

       if(jj.ne.jge) then
        jg=ajg+0.01
        je=aje+0.01 
        hLJe=sqrt(float(2*Lp+1))/sqrt(float(2*je+1))*(-1.)**Lp
        ajg=float(jg)
        aje=float(je)
        do i=-je,je,1
         em=float(i)
         do j=-jg,jg,1
          gm=float(j)
          do M=-Lp,Lp
           Vje_L_jg(i,M,j)=
     &      clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe
          end do
         end do
        end do
c      write(6,'(a,f4.1,i3,f4.1,4x,4i3)')
c     & '...aje,La,ajg je,Lp,jg,jge=',aje,La,ajg,je,Lp,jg,jge
       else
        jg=2*ajg+0.01
        je=2*aje+0.01
        hLJe=sqrt(float(2*Lp+1))/sqrt(float(je+1))*(-1.)**Lp
        do i=-je,je,2
         em=float(i)/2.
         do j=-jg,jg,2
          gm=float(j)/2.
          do M=-Lp,Lp
           Vje_L_jg(i,M,j)=
     &       clebsch(float(Lp),float(M),ajg,gm,aje,em)*hLJe
c          write(6,'(a,f15.4)')' Vje_L_jg(i,M,j)=', Vje_L_jg(i,M,j)
          end do
         end do
        end do
c      write(6,'(a,2(f4.1,i3,f4.1,4x),i3)')
c     & '...aje,La,ajg je,Lp,jg,jge=',aje,La,ajg,a_je,Lp,a_jg,jge
       end if

       do mj=-jg,jg,2
        wjg(mj)=sqrt(float((jg+mj+2)*(jg-mj)))/2.
       end do
       do mj=-je,je,2
        wje(mj)=sqrt(float((je+mj+2)*(je-mj)))/2.
       end do
      end if
      
      return
      end

      subroutine hamJgJe(amueg,amuee,QgdQe,cTms,hv,efgm,Eagd,V1)
      include 'comglb.for'
      include 'comnuc.for'
      real amueg,amuee,QgdQe,cTms
      parameter(NPD=maxj+1)
c     jge =(2*je+1)*2*jg+1),  maxj>je,jg  , |je-jg|=1 ->maxjge

      complex hm(-maxj:maxj,-maxj:maxj), Eve(-maxj:maxj,-maxj:maxj),
     &        Evg(-maxj:maxj,-maxj:maxj),AA(NPD,NPD),VV(NPD,NPD),
     &        V1(-1:1,maxjge),hv(-1:1),efgm(-2:2),C20,C2m1,C2m2,
     &        H10,H1m1,hc1
      dimension Ee(-maxj:maxj),Eg(-maxj:maxj),Eagd(maxjge),DD(NPD)

c       write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm
c      magnetic energy
c      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I
c              (largest moment is mue - not mue*I(=3/2)-)
C          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I
c      electric energy
c      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik
c              Sum;k q2k*C2-k*(-1)**k
c
c      Abragam and Bleaney chapter 17 ,p. 680
c              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))
c              q21=-eQ/I(2I-1)*(Iz*I+ + I+*Iz)sqrt(3/8)
c             q2-1= eQ/I(2I-1)*(Iz*I- + I-*Iz)sqrt(3/8)
c              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)
c             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)
c              C20= 1/2*Vzz
c              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)
c             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)
c              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3
c             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3
c     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)
 
c     exited state
      sq3d8=sqrt(3./8.)
      sq2=sqrt(2.)
       je=a_je*2.+0.01
       j=je

       do m=-j,j,2
       do n=-j,j,2
        hm(n,m)=(0.,0.)
       end do
       end do

       hmag=amuee/float(j)/cTms
       H10=-hmag*hv(0)
       H1m1=-hmag*hv(-1)

       if(j.gt.1) then
        hI2IM1=float(j*(j-1))/2.
        C20=efgm(0)/hI2IM1
        C2m1=efgm(-1)/hI2IM1
        C2m2=efgm(-2)/hI2IM1
        h=float(j*(j+2))
        do m=-j,j,2
         q20=(float(3*m**2)-h)/8.
         hm(m,m)= C20*q20 + m*H10
        end do

        do m=j-2,-j,-2
         q21=-float(m+1)*wje(m)*sq3d8        !  m+1= (m+2 + m)/2
         hm(m+2,m)= -C2m1*q21 + H1m1*wje(m)*sq2
        end do
       else
         hm(1,1)= H10
         hm(-1,-1)= -H10
         hm(1,-1)=H1m1*sq2
       end if

       if(j.ge.2) then
        do m=j-4,-j,-2
         q22=wje(m+2)*wje(m)*sq3d8
         hm(m+4,m)= C2m2*q22
        end do
       end if
c      write(6,'(a,4i4)') ' jacobi',maxj,j
c      do m=-j,j,2
c       write(6,'(8f10.6)') (hm(n,m),n=-j,j,2)
c      end do
      mj=maxj
      call jacobihf(mj,j,hm,Ee,Eve,j+1,AA,DD,VV)
c      write(6,'(8f10.6)') (Ee(n),n=-j,j,2)
c       do m=-j,j,2
c        write(6,'(8f10.6)') (Eve(n,m),n=-j,j,2)
c       end do

c      groundstate
         jg=a_jg*2.+0.01
         j=jg

         do m=-j,j,2
         do n=-j,j,2
          hm(n,m)=(0.,0.)
         end do
         end do

         hmag=amueg/float(j)/cTms
         H10=-hmag*hv(0)
         H1m1=-hmag*hv(-1)



         if(j.gt.1) then
          hI2IM1=float(j*(j-1))/2.
          C20=efgm(0)/hI2IM1*QgdQe
          C2m1=efgm(-1)/hI2IM1*QgdQe
          C2m2=efgm(-2)/hI2IM1*QgdQe
          h=float(j*(j+2))
          do m=-j,j,2
           q20=(float(3*m**2)-h)/8.
           hm(m,m)= C20*q20 + m*H10
          end do

          do m=j-2,-j,-2
           q21=-float(m+1)*wjg(m)*sq3d8        !  m+1= (m+2 + m)/2
           hm(m+2,m)= -C2m1*q21 + H1m1*wjg(m)*sq2
          end do
         else
           hm(1,1)= H10
           hm(-1,-1)= -H10
           hm(1,-1)=H1m1*sq2
         end if

         if(j.ge.2) then
           do m=j-4,-j,-2
            q22=wjg(m+2)*wjg(m)*sq3d8
            hm(m+4,m)= C2m2*q22
           end do
         end if

         mj=maxj
         call jacobihf(mj,j,hm,Eg,Evg,j+1,AA,DD,VV)
c         write(6,'(8f10.6)') (Eg(n),n=-j,j,2)
c         do m=-j,j,2
c          write(6,'(8f10.6)') (Evg(n,m),n=-j,j,2)
c         end do

c        ie , ig count the exited and ground states

         ieg=0
        do ie=-je,je,2
        do ig=-jg,jg,2
         ieg=ieg+1
         Eagd(ieg)=Ee(ie)-Eg(ig)

c      aM= <Je,ie|Htr(M)|Jg,ig>
c      eigenstates are |Je,ie>= Sum;me  UE(me,ie)*|Je,me>  ;  Eve=UE+
c      eigenstates are |Jg,ig>= Sum;mg  UG(mg,ig)*|Jg,mg>  ;  Evg=UG+
c      <Je,ie|Htr(M)|Jg,ig>=
c               Sum;me conjg(UE(me,ie))*UG(mg,ig)*<Je,me|Htr(M)|Jg,mg>
c               Sum;me Eve(ie,me)*conjg(Evg(ig,mg))*<Je,me|Htr(M)|Jg,mg>

         do M=-1,1
           hc1=(0.,0.)
          do me=je,-je,-2
          do mg=jg,-jg,-2
           hc1=hc1+ Eve(ie,me)*conjg(Evg(ig,mg))*
     &                    Vje_L_jg(me,M,mg)
          end do
          end do
          V1(M,ieg)=hc1
        end do

        end do ! ig
        end do ! ie
       return
       end

      subroutine sphere(iset,isym,iOM,tetah,phih)
      parameter (niset=128*24)
      dimension wh4(8),wh8(16),wh16(32),wh32(64),wh64(128),wh128(256),
     &          eh(3,128),tetah(niset),phih(niset),hmat(3,3)

      real mat(3,3,24),tritra(3,3),hvec(3)
      dimension nel(24),nd4(3),nd2(6),nc2(12),nd3(4),nc2y(12)

c     symmetry of the hamiltonian (subgroup of O)
      data  nd4/1,5,8/                          ! D4 (C4 || z-axis)
      data  nd2/1,2,5,8,17,18/                  ! D2
      data  nc2/1,2,3,4,5,7,8,13,17,18,19,22/   ! C2 (z-axis)
      data  nd3/1,2,3,4/                        ! D3 (C3 || {111}=z-axis)
      data nc2y/1,2,3,4,5,7,8,10,13,14,15,16/   ! c2 (y-axis)

c     Directions  whi(teta,phi)  for the integration
c     over the sphere.
c     Optimized values are calculated by K. Knese and H. Spiering
c     hopefully  be published in Nuclear Instruments and Methods
c     (it was only hope - hs)

c     definition of isym (spezified by the calling routine):
c     C4 || z-axis                     C3 || z-axis
c     cubic    isym=11                 cubic     isym=21
c     D4       isym=12                 D3             22
c     D2            13                 C2             23
c     C2            14                 C1             24
c     C1            15

c     iOM  (i-Omega) number of points, equal weights  

c     npt: number of points on 1/48 sphere,  npt=2**(iset+1)

c   iset=1,  npt=4
      data wh4/0.50931527,0.50792264,
     &0.27489180,0.37415606,0.76289238,0.61459026,0.66616440,0.19291352/

c   iset=2,   npt=8
      data wh8/0.45014353,0.59730703,0.36578153,0.23969338,
     &0.62724937,0.62785053,0.70269323,0.14007076,0.54217478,0.21585054,
     &0.19518280,0.41244099,0.73632017,0.41330862,0.81652321,0.67248618/

c   iset=3, npt=16
      data wh16/0.44673522,0.65209063,
     &0.39882402,0.37679617,0.66592311,0.50161547,0.72801832,0.10382966,
     &0.53239609,0.41141732,0.28698129,0.59693000,0.75673269,0.33122264,
     &0.79638500,0.53217095,0.58130750,0.67222854,0.28851947,0.18442790,
     &0.72069964,0.69437716,0.59086681,0.10398588,0.45959846,0.13273056,
     &0.14011330,0.39225235,0.64118008,0.28631739,0.85637326,0.70762098/

c   iset=4  npt=32
      data wh32/0.64071190,0.57645950,0.43123850,0.29009320,
     &0.68319750,0.33438050,0.64283800,0.06647810,0.60681060,0.41737370,
     &0.54348980,0.53527600,0.49121940,0.69436360,0.74206620,0.60510160,
     &0.84010800,0.61987350,0.18823200,0.21923990,0.78556260,0.72596070,
     &0.59067880,0.24252720,0.36540130,0.11822190,0.34844340,0.40180900,
     &0.67767340,0.18925870,0.77554080,0.36778110,0.58697670,0.70703960,
     &0.27727140,0.18847500,0.68505590,0.71814090,0.55002870,0.09153870,
     &0.46414670,0.10052610,0.09804880,0.40776720,0.51761790,0.33132110,
     &0.88470430,0.73266380,0.75839300,0.22549150,0.21570320,0.59234190,
     &0.30300640,0.63100620,0.70765100,0.47355060,0.80387460,0.49811190,
     &0.74295690,0.06978730,0.39446290,0.67054710,0.45089600,0.49737200/

c   iset=5  npt=64
      data wh64/0.63796252,0.53536674,
     &0.43132552,0.25423716,0.66434956,0.34897385,0.63427965,0.05507200,
     &0.61596048,0.41967759,0.52887425,0.60610974,0.49053477,0.71922206,
     &0.70652064,0.55807979,0.80360321,0.66266284,0.19304277,0.19332170,
     &0.76608774,0.74184447,0.55313133,0.20711391,0.38654876,0.08285910,
     &0.30415234,0.31653168,0.61453987,0.16012202,0.79721312,0.41374436,
     &0.62728671,0.73358423,0.36657497,0.24368229,0.66504418,0.64140135,
     &0.51225205,0.06519040,0.31838616,0.09815862,0.06909730,0.41077964,
     &0.49712415,0.32275885,0.90530416,0.74865003,0.76658952,0.22685795,
     &0.21717801,0.63759705,0.32314606,0.51268954,0.72964951,0.38239621,
     &0.77518581,0.57461502,0.75500166,0.04699499,0.35152909,0.69872575,
     &0.46270878,0.57649591,0.59642637,0.62597909,0.44453941,0.41853262,
     &0.81864237,0.50299907,0.69228551,0.15725422,0.55436258,0.37081089,
     &0.37994344,0.40647581,0.71546056,0.27639648,0.84380538,0.58888644,
     &0.57134376,0.50592583,0.24569803,0.40726979,0.73434775,0.65349403,
     &0.75604333,0.13910419,0.49104284,0.19158298,0.13080068,0.22909680,
     &0.65638496,0.23961491,0.87245581,0.67109409,0.55853163,0.72777777,
     &0.25347990,0.12665297,0.69651588,0.73818578,0.57187492,0.06495971,
     &0.44776407,0.07780694,0.15511034,0.59363643,0.59926215,0.29188063,
     &0.83571615,0.74475490,0.78011876,0.32155618,0.50746948,0.46897202,
     &0.28191180,0.67261738,0.68296148,0.45638684,0.75043819,0.48129129,
     &0.69408491,0.05420525,0.42327717,0.71275927,0.39666205,0.56559666/

c   iset=6  npt=128
      data wh128/0.67050290,0.61282610,0.48391970,0.24785680,
     &0.69689350,0.30456670,0.61363770,0.03812250,0.66928050,0.42315660,
     &0.50950930,0.56013640,0.45057980,0.73327000,0.72396550,0.62350130,
     &0.84768110,0.70053150,0.23324840,0.29368850,0.75128880,0.69010590,
     &0.56456020,0.27758250,0.36164060,0.18813310,0.36034330,0.33033460,
     &0.68710530,0.09008540,0.79344900,0.35069060,0.63445610,0.74894360,
     &0.40166240,0.26732920,0.65874330,0.67974170,0.54354150,0.12120870,
     &0.33681580,0.07318720,0.09108610,0.54076460,0.52264390,0.31170490,
     &0.89592780,0.70518090,0.72720200,0.19075880,0.20894070,0.45764660,
     &0.34126540,0.57795870,0.75584090,0.39519840,0.80487640,0.58187560,
     &0.76507620,0.09197010,0.35993360,0.71985180,0.47748480,0.63947290,
     &0.61442060,0.59795630,0.44854860,0.42381200,0.81978070,0.47275870,
     &0.60728430,0.24180890,0.58111580,0.44630160,0.40592960,0.38519000,
     &0.68762450,0.23155610,0.82501750,0.64173190,0.63284990,0.47620550,
     &0.25238410,0.51098920,0.77509270,0.63354460,0.76926130,0.15873270,
     &0.49576360,0.13970320,0.11181730,0.19033350,0.65040310,0.26981800,
     &0.85414490,0.59124070,0.57013370,0.66035070,0.27690100,0.22426730,
     &0.72889670,0.75214290,0.56671790,0.04147380,0.47299710,0.05209460,
     &0.16794770,0.38244340,0.61143530,0.32277650,0.87161580,0.75714550,
     &0.78331720,0.28758850,0.54310210,0.49514530,0.22555590,0.68356940,
     &0.68374870,0.49377820,0.76975510,0.45883750,0.72573650,0.11922250,
     &0.43131460,0.62505610,0.41557770,0.50840510,0.64937260,0.54759890,
     &0.40929930,0.15781030,0.65827610,0.34867440,0.66222070,0.03287810,
     &0.62038820,0.40086740,0.52399800,0.65116060,0.49613330,0.73757630,
     &0.70255790,0.56008600,0.79925390,0.69576790,0.20107320,0.12800860,
     &0.77595840,0.75397790,0.52764260,0.21309610,0.38208280,0.05836410,
     &0.32614470,0.42042810,0.64038110,0.10745030,0.80554150,0.41231200,
     &0.58727730,0.74519920,0.32083610,0.24758130,0.61467060,0.67262690,
     &0.51866300,0.04393740,0.29396580,0.07751370,0.04866540,0.37280360,
     &0.48332240,0.35897110,0.92000360,0.75954530,0.77500880,0.22351860,
     &0.17990620,0.66234960,0.29735010,0.55203310,0.70668450,0.37529250,
     &0.75454530,0.57142910,0.76118960,0.03065280,0.31539570,0.71096360,
     &0.46148630,0.53636630,0.55989470,0.57900320,0.44401370,0.29774320,
     &0.78636590,0.52078030,0.63517530,0.18413320,0.53022810,0.40558420,
     &0.37037040,0.46985620,0.73509500,0.26069540,0.83602680,0.53245390,
     &0.59540510,0.52526850,0.28283240,0.38179190,0.70432910,0.68407180,
     &0.68002900,0.16225090,0.45228860,0.17178010,0.15688830,0.13550300,
     &0.57434520,0.18776060,0.87406790,0.64876980,0.54162850,0.74112360,
     &0.24537610,0.08801680,0.68200380,0.75059850,0.59501910,0.11728470,
     &0.42964940,0.05476270,0.13502290,0.60627190,0.57040280,0.36378110,
     &0.82353760,0.75565680,0.74468360,0.32913840,0.49409160,0.46347000,
     &0.27053210,0.69931900,0.71926570,0.44336370,0.73543600,0.50839710,
     &0.71513670,0.03420950,0.40503050,0.72764940,0.38569990,0.60504190/


      pi=atan(1.)*4.
      rad=pi/180.

      if(iset.gt.6) iset=6
      npt=2**(iset+1)

      goto(11,12,13,14,15,16) iset

11    do i=1,npt
       tetah(i)=wh4(2*i-1)
       phih(i) =wh4(2*i)
      end do
      goto 17
12    do i=1,npt
       tetah(i)=wh8(2*i-1)
       phih(i) =wh8(2*i)
      end do
      goto 17
13    do i=1,npt
       tetah(i)=wh16(2*i-1)
       phih(i) =wh16(2*i)
      end do
      goto 17
14    do i=1,npt
       tetah(i)=wh32(2*i-1)
       phih(i) =wh32(2*i)
      end do
      goto 17
15    do i=1,npt
       tetah(i)=wh64(2*i-1)
       phih(i) =wh64(2*i)
      end do
      goto 17
16    continue
      do i=1,npt
       tetah(i)=wh128(2*i-1)
       phih(i) =wh128(2*i)
      end do
17    continue

      do i=1,npt
      snt=sin(tetah(i))
       eh(1,i)=snt*cos(phih(i))
       eh(2,i)=snt*sin(phih(i))
       eh(3,i)=cos(tetah(i))
      end do


c     rotation matrices of the cubic group O

         do k=1,24
          do i=1,3
          do j=1,3
           mat(i,j,k)=0.0
          end do
          end do
         end do

c         1-element
          do i=1,3
           mat(i,i,1)=1.0
          end do
c         c4-rotation z-axis
          mat(1,2,2)=-1.
          mat(2,1,2)=1.
          mat(3,3,2)=1.
c         c4**2
          mat(1,1,3)=-1.
          mat(2,2,3)=-1.
          mat(3,3,3)=1.
c         c4**3
          mat(1,2,4)=1.
          mat(2,1,4)=-1.
          mat(3,3,4)=1.
c         c4-rotation x-axis
          mat(1,1,5)=1.
          mat(2,3,5)=-1.
          mat(3,2,5)=1.
c         c4**2
          mat(1,1,6)=1.
          mat(2,2,6)=-1.
          mat(3,3,6)=-1.
c         c4**3
          mat(1,1,7)=1.
          mat(2,3,7)=1.
          mat(3,2,7)=-1.
c         c4-rotation y-axis
          mat(1,3,8)=1.
          mat(2,2,8)=1.
          mat(3,1,8)=-1.
c         c4**2
          mat(1,1,9)=-1.
          mat(2,2,9)=1.
          mat(3,3,9)=-1.
c         c4**3
          mat(1,3,10)=-1.
          mat(2,2,10)=1.
          mat(3,1,10)=1.
c         c2-rotation c2xy
          mat(1,2,11)=1.
          mat(2,1,11)=1.
          mat(3,3,11)=-1.
c         c2-rotation c2-xy
          mat(1,2,12)=-1.
          mat(2,1,12)=-1.
          mat(3,3,12)=-1.
c         c2-rotation c2xz
          mat(1,3,13)=1.
          mat(2,2,13)=-1.
          mat(3,1,13)=1.
c         c2-rotation c2-xz
          mat(1,3,14)=-1.
          mat(2,2,14)=-1.
          mat(3,1,14)=-1.
c         c2-rotation c2yz
          mat(1,1,15)=-1.
          mat(2,3,15)=1.
          mat(3,2,15)=1.
c         c2-rotation c2-yz
          mat(1,1,16)=-1.
          mat(2,3,16)=-1.
          mat(3,2,16)=-1.
c         c3-rotation {1,1,1}
          mat(1,3,17)=1.
          mat(2,1,17)=1.
          mat(3,2,17)=1.
c         c3**2
          mat(1,2,18)=1.
          mat(2,3,18)=1.
          mat(3,1,18)=1.
c         c3-rotation {-1,1,1}
          mat(1,2,19)=-1.
          mat(2,3,19)=1.
          mat(3,1,19)=-1.
c         c3**2
          mat(1,3,20)=-1.
          mat(2,1,20)=-1.
          mat(3,2,20)=1.
c         c3-rotation {1,-1,1}
          mat(1,2,21)=-1.
          mat(2,3,21)=-1.
          mat(3,1,21)=1.
c         c3**2
          mat(1,3,22)=1.
          mat(2,1,22)=-1.
          mat(3,2,22)=-1.
c         c3-rotation {-1,-1,1}
          mat(1,3,23)=-1.
          mat(2,1,23)=1.
          mat(3,2,23)=-1.
c         c3**2
          mat(1,2,24)=1.
          mat(2,3,24)=-1.
          mat(3,1,24)=-1.

         isym1=isym/10
         isym2=isym-10*isym1
         goto(100,200)isym1

  100    goto(110,120,130,140,150)isym2
c  110   cubic   (C4z)
c  120   D4        "
c  130   D2      (C2z)
c  140   C2z
c  150   C1

  110   nkl=1
        nel(1)=1
        goto 400

  120   nkl=3
        do i=1,nkl
         nel(i)=nd4(i)
        end do
        goto 400

  130   nkl=6
        do i=1,nkl
         nel(i)=nd2(i)
        end do
        goto 400

  140   nkl=12
        do i=1,nkl
         nel(i)=nc2(i)
        end do
        goto 400

  150   nkl=24
        do i=1,nkl
         nel(i)=i
        end do
        goto 400

c        trigonal coordinate system
  200   continue
        sq2=1./sqrt(2.)
        sq3=1./sqrt(3.)

        tritra(1,1)=sq2*sq3
        tritra(1,2)=-sq2
        tritra(1,3)=sq3
        tritra(2,1)=sq2*sq3
        tritra(2,2)=sq2
        tritra(2,3)=sq3
        tritra(3,1)=-sq3/sq2
        tritra(3,2)=0.
        tritra(3,3)=sq3

         goto(210,220,230,240)isym2
c  210   cubic   (C3z)
c  220   D3        "
c  230   C2y
c  240   C1

  210   nkl=1
        nel(1)=1
        goto 300

  220   nkl=4
        do i=1,nkl
         nel(i)=nd3(i)
        end do
        goto 300

  230   nkl=12
        do i=1,nkl
         nel(i)=nc2y(i)
        end do
        goto 300

  240   nkl=24
        do i=1,nkl
         nel(i)=i
        end do


  300    continue
c        transformation of the matrices to the koordinate system z={1,1,1}
         do m=1,nkl
           l=nel(m)
           do i=1,3
           do j=1,3
            h=0.
            do k=1,3
            do kk=1,3
             h=h+tritra(k,i)*mat(k,kk,l)*tritra(kk,j)
            end do
            end do
            hmat(i,j)=h
           end do
           end do
           do i=1,3
           do j=1,3
            mat(i,j,l)=hmat(i,j)
           end do
           end do
         end do

c        transformation of the points to the trigonal system
         do k=1,npt
           do i=1,3
            h=0.
            do j=1,3
             h=h+tritra(j,i)*eh(j,k)
            end do
            hvec(i)=h
           end do
           do i=1,3
            eh(i,k)=hvec(i)
           end do
         end do

  400   continue

c        calculation of all vectors

         iOM=0
         do k=1,npt
         do m=1,nkl
           iOM=iOM+1
           l=nel(m)
           do i=1,3
            h=0.
            do j=1,3
             h=h+mat(i,j,l)*eh(j,k)
            end do
            hvec(i)=h
           end do
           ehz=hvec(3)
           snt=sqrt(1.-ehz**2)
           tet=atan(snt/ehz)
           if(ehz.lt.0.) tet=pi+tet
           tetah(iOM)=tet
           ehx=hvec(1)
           ehy=hvec(2)
           ph=atan(ehy/ehx)
           if(ehx.lt.0.) ph=ph+pi
           phih(iOM)=ph
         end do
         end do

      return
      end

      subroutine sym_equiv(ncase,timeinvers,nloop,ctimeinv,
     &                         d1,d2)
      implicit none
      integer ncase,nloop,maxloop 
      parameter (maxloop=5)
      complex d1(-1:1,-1:1,maxloop),d2(-2:2,-2:2,maxloop),
     &        ctimeinv(maxloop)

      real dj(-5:5,-5:5),
     &     C4y2(3),C2xy(3),C3111(6),C4z2a(9),C4z2b(9),C2_xy(15),
     &     C2XZ(3),C4XYZ2(3),C3Z(6),C4xZ2a(9),C4xZ2b(9),C2Y(15),
     &     rad,fn,fm,timeinvers
      integer m,n,j,k,itime
      character ch*8

      data  C4y2/  0.000,180.000,  0.000/
      data  C2xy/270.000,180.000,  0.000/
      data C3111/ 90.000, 90.000,180.000,  0.000, 90.000, 90.000/
      data C4z2a/180.000,  0.000,  0.000,180.000,180.000,  0.000,
     &             0.000,180.000,  0.000/
      data C4z2b/180.000,  0.000,  0.000,270.000,180.000,  0.000,
     &            90.000,180.000,  0.000/
      data C2_xy/ 90.000,180.000,  0.000,180.000, 90.000,  0.000,
     &           270.000, 90.000,270.000, 90.000, 90.000,180.000,
     &             0.000, 90.000, 90.000/

      data   C2XZ/  0.000, 70.529,180.000/
      data C4XYZ2/ 60.000,109.471,120.000/
      data    C3Z/240.000,  0.000,  0.000,120.000,  0.000,  0.000/
      data C4xZ2a/180.000,109.471,  0.000,300.000,109.471,240.000,
     &             60.000,109.471,120.000/
      data C4xZ2b/180.000,109.471,  0.000,  0.000, 70.529,180.000,
     &              0.000,180.000,  0.000/
      data    C2Y/  0.000,180.000,  0.000,120.000,180.000,  0.000,
     &            240.000,180.000,  0.000,240.000,  0.000,  0.000,
     &            120.000,  0.000,  0.000/
  

      if(ncase.eq.0) then
       nloop=0
       do n=1,maxloop
        ctimeinv(n)=cmplx(1.0,0.0)
       end do
       return
      end if

      rad=atan(1.)/45.
      goto(1,2,3,4,5,6,7,8,9,10,11,12) ncase

c----------------------  C4z || z  -----------------------------------
 1    continue
      nloop=1
      call dewigner(2,C4y2(2)*rad,dj)
      do m=-2,2
       do n=-2,2
        fm=float(m)*C4y2(1)*rad
        fn=float(n)*C4y2(3)*rad
        d2(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do

      call dewigner(1,C4y2(2)*rad,dj)
      do m=-1,1
       do n=-1,1
        fm=float(m)*C4y2(1)*rad
        fn=float(n)*C4y2(3)*rad
        d1(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do
      goto 100

 2    continue
      nloop=1
      call dewigner(2,C2xy(2)*rad,dj)
      do m=-2,2
       do n=-2,2
        fm=float(m)*C2xy(1)*rad
        fn=float(n)*C2xy(3)*rad
        d2(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do

      call dewigner(1,C2xy(2)*rad,dj)
      do m=-1,1
       do n=-1,1
        fm=float(m)*C2xy(1)*rad
        fn=float(n)*C2xy(3)*rad
        d1(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do
      goto 100

 3    continue
      nloop=2
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C3111(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C3111(k+1)*rad
         fn=float(n)*C3111(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C3111(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C3111(k+1)*rad
         fn=float(n)*C3111(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 4    continue
      nloop=3
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C4z2a(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C4z2a(k+1)*rad
         fn=float(n)*C4z2a(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C4z2a(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C4z2a(k+1)*rad
         fn=float(n)*C4z2a(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 5    continue
      nloop=3
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C4z2b(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C4z2b(k+1)*rad
         fn=float(n)*C4z2b(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C4z2b(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C4z2b(k+1)*rad
         fn=float(n)*C4z2b(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 6    continue
      nloop=5
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C2_xy(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C2_xy(k+1)*rad
         fn=float(n)*C2_xy(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C2_xy(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C2_xy(k+1)*rad
         fn=float(n)*C2_xy(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

c----------------------  C3111 || z  -----------------------------------

 7    continue
      nloop=1
      call dewigner(2,C2XZ(2)*rad,dj)
      do m=-2,2
       do n=-2,2
        fm=float(m)*C2XZ(1)*rad
        fn=float(n)*C2XZ(3)*rad
        d2(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do

      call dewigner(1,C2XZ(2)*rad,dj)
      do m=-1,1
       do n=-1,1
        fm=float(m)*C2XZ(1)*rad
        fn=float(n)*C2XZ(3)*rad
        d1(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do
      goto 100

 8    continue
      nloop=1
      call dewigner(2,C4XYZ2(2)*rad,dj)
      do m=-2,2
       do n=-2,2
        fm=float(m)*C4XYZ2(1)*rad
        fn=float(n)*C4XYZ2(3)*rad
        d2(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do

      call dewigner(1,C4XYZ2(2)*rad,dj)
      do m=-1,1
       do n=-1,1
        fm=float(m)*C4XYZ2(1)*rad
        fn=float(n)*C4XYZ2(3)*rad
        d1(m,n,1)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
       end do
      end do
      goto 100

 9    continue
      nloop=2
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C3Z(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C3Z(k+1)*rad
         fn=float(n)*C3Z(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C3Z(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C3Z(k+1)*rad
         fn=float(n)*C3Z(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 10   continue
      nloop=3
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C4z2a(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C4xZ2a(k+1)*rad
         fn=float(n)*C4xZ2a(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C4xZ2a(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C4xZ2a(k+1)*rad
         fn=float(n)*C4xZ2a(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 11   continue
      nloop=3
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C4xZ2b(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C4xZ2b(k+1)*rad
         fn=float(n)*C4xZ2b(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C4xZ2b(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C4xZ2b(k+1)*rad
         fn=float(n)*C4xZ2b(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do
      goto 100

 12   continue
      nloop=5
      do j=1,nloop
       k=3*(j-1)
       call dewigner(2,C2Y(k+2)*rad,dj)
       do m=-2,2
        do n=-2,2
         fm=float(m)*C2Y(k+1)*rad
         fn=float(n)*C2Y(k+3)*rad
         d2(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do

       call dewigner(1,C2Y(k+2)*rad,dj)
       do m=-1,1
        do n=-1,1
         fm=float(m)*C2Y(k+1)*rad
         fn=float(n)*C2Y(k+3)*rad
         d1(m,n,j)=cmplx(cos(fm+fn),-sin(fm+fn))*dj(m,n)   
        end do
       end do
      end do

 100  continue

      itime=timeinvers
      call itoc8(ch,itime)
      if(itime.gt.1.and.maxloop.lt.7) then
       m=3
       do while(ch(m:m).ne.' '.and.m.le.maxloop+2)   
        if(ch(m:m).eq.'1') then
         ctimeinv(m-2)=cmplx(1.0,0.0)
        else
         ctimeinv(m-2)=cmplx(-1.0,0.0)
        end if
        m=m+1
       end do
      else
       m=2
      end if
      if(m-2.lt.nloop.or.maxloop.gt.6) then
       do n=1,maxloop
        ctimeinv(n)=cmplx(1.0,0.0)
       end do
      end if

      return
      end
